
typedef struct ItemType
{
	char msg[128];
};


template<class ItemType>
class QueType
{
public: 
    QueType();
    QueType(int max);
    ~QueType();
    void MakeEmpty();
    bool IsEmpty() const;
    bool IsFull() const;
    void Enqueue(ItemType newItem);
    void Dequeue(ItemType& item);

private:
    int front;
    int rear;
    ItemType* items;
	int maxQue;
}; 

template<class ItemType>
QueType<ItemType>::QueType(int max)
{
  maxQue = max + 1;
  front = maxQue - 1;
  rear = maxQue - 1;
  items = new ItemType[maxQue];
}

template<class ItemType>
QueType<ItemType>::QueType() 
{
  maxQue = 501;
  front = maxQue - 1;
  rear = maxQue - 1;
  items = new ItemType[maxQue];
}

template<class ItemType>
QueType<ItemType>::~QueType()         // Class destructor
{
  delete [] items;
}

template<class ItemType>
void QueType<ItemType>::MakeEmpty()
{
  front = maxQue - 1;
  rear = maxQue - 1;
}

template<class ItemType>
bool QueType<ItemType>::IsEmpty() const

{
  return (rear == front);
}

template<class ItemType>
bool QueType<ItemType>::IsFull() const

{
  return ((rear + 1) % maxQue == front);
}

template<class ItemType>
void QueType<ItemType>::Enqueue(ItemType newItem)
{
  if (IsFull())
    throw FullQueue();
  else
  {
    rear = (rear +1) % maxQue;
    items[rear] = newItem;
  }
}

template<class ItemType>
void QueType<ItemType>::Dequeue(ItemType& item)
{
  if (IsEmpty())
    throw EmptyQueue();
  else
  {
    front = (front + 1) % maxQue;
    item = items[front];
  }
}

