
#include <winsock2.h>
#include "osp_session.h"

#define BUFSIZE 100


#define SESSION_BUFFER_SIZE 10

SessionClass::SessionClass()
{
	count = 0;
}

SessionClass::~SessionClass()
{
}

int SessionClass::insertSession(const Session_Record& SR)
{
	if (count >= SESSION_MAX_SIZE)
		return SES_BUFFERFULL;
	ses[count] = SR;
	count ++;
	return SES_INSERTED;
}

int SessionClass::findSessionIndex(const int dlgID)
{
	bool found = false;
	int i = 0;

	while(i < count && !found)
	{
		if(ses[i].myDlgID==dlgID)
		{
			found = true;
		}
		i++;
	}

	if (found)
		return (i-1);
	else
		return SES_RECORDNOTFOUND;
}

int SessionClass::findSessionIndex(const char* FriendID)
{
	bool found = false;
	int i = 0;

	while(i < count && !found)
	{
		found = true;

		if(strcmp(ses[i].FID,FriendID))
			found = false;
	
		i++;
	}

	if (found)
		return (i-1);
	else
		return SES_RECORDNOTFOUND;
}

/*
int SessionClass::findSessionIndex(const int FriendDlgID)
{
	bool found = false;
	int i =0;
	while (i<count && !found)
	{
		if(ses[i].fdDlgID == FriendDlgID)
		{
			found = true;
			break;
		}
		i++;
	}
	if (found)
		return i;
	else
		return SES_RECORDNOTFOUND;
}
*/

int SessionClass::findSessionIndex(HWND hdlg)
{
	bool found = false;
	int i =0;
	while (i<count && !found)
	{
		if(ses[i].hChatList == hdlg)
		{
			found = true;
			break;
		}
		i++;
	}
	if (found)
		return i;
	else
		return SES_RECORDNOTFOUND;
}


int SessionClass::findSession(const char* FriendID, Session_Record& SR)
{
	int i;
	if ((i = findSessionIndex(FriendID)) != SES_RECORDNOTFOUND)
	{
		SR = ses[i];
		return SES_RECORDFOUND;
	}
	else
		return SES_RECORDNOTFOUND;
}

int SessionClass::findSession(const int dlgID, Session_Record& SR)
{
	int i;
	if ((i = findSessionIndex(dlgID)) != SES_RECORDNOTFOUND)
	{
		SR = ses[i];
		return SES_RECORDFOUND;
	}
	else
		return SES_RECORDNOTFOUND;
}

int SessionClass::findSession(const HWND hdlg, Session_Record& SR)
{
	int i;
	if ((i = findSessionIndex(hdlg)) != SES_RECORDNOTFOUND)
	{
		SR = ses[i];
		return SES_RECORDFOUND;
	}
	else
		return SES_RECORDNOTFOUND;
}


int SessionClass::deleteSession(const char* FriendID)
{
	int i;
	if ((i = findSessionIndex(FriendID)) != SES_RECORDNOTFOUND)
	{
		for(int j = i; j < count-1; j++)
			ses[j] = ses[j+1];
		count --;
		return SES_RECORDFOUND;
	}
	else
		return SES_RECORDNOTFOUND;
}

int SessionClass::deleteSession(const int dlgID)
{
	int i = findSessionIndex(dlgID);
	if (i != SES_RECORDNOTFOUND)
	{
		for (int j = i; j < count-1; j++)
			ses[j] = ses[j+1];
		count--;
		return SES_RECORDFOUND;
	}
	else
		return SES_RECORDNOTFOUND;
}

int SessionClass::modifySession(const int dlgID, const Session_Record& SR)
{
	int i = findSessionIndex(dlgID);
	if (i != SES_RECORDNOTFOUND)
	{
		ses[i] = SR;
		return SES_RECORDFOUND;
	}
	else
		return SES_RECORDNOTFOUND;
}
