#include "osp_Tray.h"

Trayicon::Trayicon()
{

}
Trayicon::Trayicon(HINSTANCE hInst, HWND hWnd, UINT uID)
{
	t_hInst = hInst;
	t_hWnd = hWnd;
	t_uID = uID;
}

Trayicon::~Trayicon()
{

}

BOOL Trayicon::TrayInit(HINSTANCE hInst, HWND hwnd, UINT uid)
{
	t_hInst = hInst;
	t_hWnd = hwnd;
	t_uID = uid;
	return 0;
}

BOOL Trayicon::CreateIcon(UINT uCallbackMessage, LPCTSTR szToolTip, HICON icon)
{
	ZeroMemory(&uid, sizeof uid);
    uid.cbSize = sizeof(uid);
    uid.hWnd = t_hWnd;
    uid.uID = t_uID;
	uid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	uid.uCallbackMessage = uCallbackMessage;
    uid.hIcon = icon;
    strcpy(uid.szTip, szToolTip);

    return Shell_NotifyIcon(NIM_ADD, &uid);
}

BOOL Trayicon::SetIcon(HICON hIcon)
{
	ZeroMemory(&uid, sizeof uid);
    uid.cbSize = sizeof uid;
	uid.hWnd = t_hWnd;
	uid.uID = t_uID;
	uid.uFlags = NIF_ICON;
    uid.hIcon = hIcon;
    return Shell_NotifyIcon(NIM_MODIFY, &uid);
}

BOOL Trayicon::SetToolTipText(LPCTSTR pszTip)
{
	ZeroMemory(&uid, sizeof uid);
    uid.cbSize = sizeof uid;
	uid.hWnd = t_hWnd;
	uid.uID = t_uID;
	uid.uFlags = NIF_TIP;
    strcpy(uid.szTip, pszTip);
    return Shell_NotifyIcon(NIM_MODIFY, &uid);
}

BOOL Trayicon::TrayProcess(LPARAM lParam)
{
	POINT pt;
	switch(lParam)
	{
	case WM_RBUTTONDOWN:
		// Tray Menu
		Traymenu = LoadMenu(t_hInst, MAKEINTRESOURCE(IDR_MENU_TRAY));
		Popup = GetSubMenu(Traymenu, 0);
		GetCursorPos(&pt);
		SetForegroundWindow(t_hWnd);
		TrackPopupMenu(Popup, TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			pt.x, pt.y, 0, t_hWnd, NULL);
		SetForegroundWindow(t_hWnd);
		DestroyMenu(Popup);
		DestroyMenu(Traymenu);
		break;
	case WM_LBUTTONDBLCLK:
		ShowWindow(t_hWnd, SW_RESTORE);
		ShowWindow(t_hWnd, SW_SHOW);
		break;
	}
	return 0;
}
BOOL Trayicon::TrayMenuProcess(WORD Notify)
{
	switch(Notify)	{
		case ID_TRAY_MENU1:
			SetIcon(LoadIcon(t_hInst, MAKEINTRESOURCE(IDI_ICON1)));
			break;
		case ID_TRAY_MENU2:
			SetIcon(LoadIcon(t_hInst, MAKEINTRESOURCE(IDI_ICON2)));
			break;
		case ID_TRAY_MENU3:
			SetToolTipText("Changed......^^");
			break;
		case ID_TRAY_MENU_EXIT:
			DeleteIcon();
			DestroyWindow(t_hWnd);
			break;
	}
	return 0;
}

void Trayicon::DeleteIcon()
{
	ZeroMemory(&uid, sizeof uid);
    uid.cbSize = sizeof uid;
	uid.hWnd = t_hWnd;
	uid.uID = t_uID;
	uid.uFlags = 0;
    Shell_NotifyIcon(NIM_DELETE, &uid);
}