
#include "osp_protocol.h"

////////////////////////////////Analyzing////////////////////////////////////////

int Analyze(char* buffer, 
			OSPP_Header** header, 
			OSPP_Contents_Info& Contents_Info,
			OSPP_Contents& contents)
{
	int sum = 0;
	int buf_pointer = 0;

	//Signature & Version
	*header = (OSPP_Header*)buffer;
	
	//Signature check
	if((*header)->Sig1 != OSPP_SIG1 || (*header)->Sig2 != OSPP_SIG2)
		return false;

	//Version check
	if ((*header)->Version != OSPP_VERS)
		return false;

	//Store Contents Information
	//QR type
	buf_pointer = SIGNATURE_SIZE + VERSION_SIZE;
	for ( int i = 0; i < QR_TYPE_SIZE; i++)
		Contents_Info.QR_Type[i] = buffer[buf_pointer + i];
	Contents_Info.QR_Type[i] = (char)0;

	//Req_Process (Dialog ID)
	buf_pointer += QR_TYPE_SIZE;
	Contents_Info.Req_Process = (int)buffer[buf_pointer];

	//NF & Validation check
	buf_pointer += PROCESS_NUM_SIZE;
	Contents_Info.Num_Field = (int)buffer[buf_pointer];
	if (Contents_Info.Num_Field > FIELD_LEN_MAX)
		return false;

	//FL
	buf_pointer += NUM_FIELD_SIZE;
	for ( i = 0; i < Contents_Info.Num_Field; i++)
	{
		Contents_Info.Field_Len[i] = (int)buffer[buf_pointer + i];
		sum += Contents_Info.Field_Len[i];
	}
	
	//CS
	buf_pointer += FIELD_LEN_MAX;
	Contents_Info.Check_Sum = (int)buffer[buf_pointer + i];

	//packet validation check
	if ((sum + buf_pointer) > BUFSIZE)
		return false;

	//contents
	buf_pointer += CHECK_SUM_SIZE;
	contents.data = (buffer + buf_pointer);
	return true;
}

////////////////////////////////Decoding////////////////////////////////////////
void Decode(OSPP_Contents& contents)
{
	return;
}

////////////////////////////////Packet_Processing///////////////////////////////
bool Packet_Process(OSPP_Header *header, 
					OSPP_Contents_Info& Contetnts_Info, 
					OSPP_Contents &contents,
					SOCKET c_sok, 
					char *Buffer)
{
	Session_Record SR;
/*
	switch(Contetnts_Info.QR_Type)
	{
	case OSPP_AUTH :
		   if(Sess_Buffer.findSession(c_sok,SR) > 0)
		   {//session found
				if(SR.User_Status == SS_STATUS_USERONLINE)
				{//Illegal packet	
					if(SR.Session_Status == SS_STATUS_ILLEGALTRY2)
					{//3rd illegal try, delete session, close socket
						WaitForSingleObject(hSB_Mutex, INFINITE);
							Sess_Buffer.deleteSession(c_sok);
						ReleaseMutex(hSB_Mutex);
						closesocket(c_sok);
						return false;
					}// end if
					else
					{
						SR.Session_Status = (abs(SR.Session_Status) + 1) * -1;
						Sess_Buffer.modifySession(c_sok, SR);
						strcpy(Buffer,"ERR0\0");
						return true;
					}// end else
				}// end if
				switch(AuthenCheck(contents.data, (int)*contents.Field_Len,
				   contents.data + (int)*(contents.Field_Len+1),
				   (int)*(contents.Field_Len+1)))
				{		
				case DB_RSP_WRONGPWD :						
				case DB_RSP_IDNOTFOUND :
					if (SR.User_Status == SS_STATUS_ILLEGALTRY2)
					{//3rd try, delete session, close socket
						WaitForSingleObject(hSB_Mutex, INFINITE);
							Sess_Buffer.deleteSession(c_sok);
						ReleaseMutex(hSB_Mutex);
						closesocket(c_sok);
						return false;
					}// end if
					else
					{
						SR.User_Status--;
						Sess_Buffer.modifySession(c_sok, SR);
						strcpy(Buffer, "RJCT");
						return true;
					}// end else
				case DB_RSP_APPROVED :
					SR.User_Status = SS_STATUS_USERONLINE;
					Sess_Buffer.modifySession(c_sok, SR);
					strcpy(Buffer, "APRV");
					return true;
				default :
					return false;
				}// end switch
		   }// end if
		   else
		   {
			   return false;
		   }// end else
	case OSPP_RFRS :
	case OSPP_CHTC :
	case OSPP_CCLS :
	case OSPP_SDAU :
	case OSPP_APRV :
	case OSPP_RJCT :
	case OSPP_ERR0 :
	case OSPP_SCLS :
	case OSPP_FLIF :
	case OSPP_ECHO :
	case OSPP_CHTS :
		break;
	}// end switch

  */
	return 0;
}