// osp_protocol header
#include "../buffer_module/buffer_module.h"


// Signature & Version
#define OSPP_SIG1 3267870911		//Signature 1
#define OSPP_SIG2 3133002428		//Signature 2
#define OSPP_VERS 4172926912
// client query
#define OSPP_AUTH 4123119296		//request authentication
#define OSPP_RFRS 0000000000		//refresh list
#define OSPP_CHTC 3284575427		//chat request (client)
#define OSPP_CCLS 3803307444		//closing connection (client)

// server query
#define OSPP_SDAU 4055554241		//request authentication data

// server response
#define OSPP_APRV 4172331708		//approved
#define OSPP_DNYD 2998448838		//rejected
#define OSPP_FAIL 3502688189
#define OSPP_ERR0 2948047295		//error
#define OSPP_SCLS 3803307444		//closing connection (server)
#define OSPP_FLIF 3098649540		//friend list information
#define OSPP_ECHO 3670319551		//echoed data (chat)
#define OSPP_CHTS 2915625908		//chat data (from friend)

// packet structure information
#define SIGNATURE_SIZE	 8			//size of Signature
#define VERSION_SIZE	 4			//size of Version
#define QR_TYPE_SIZE	 4			//size of QR_Type
#define PROCESS_NUM_SIZE 1			//size of process number field
#define NUM_FIELD_SIZE	 1			//size of NF field
#define FIELD_LEN_SIZE	 1			//size of FL field
#define FIELD_LEN_MAX    13			//max FL field
#define CHECK_SUM_SIZE	 1			//size of CS field

// header structure
struct OSPP_Header					
{
	unsigned int Sig1;				// Query/Request Type (4byte)
	unsigned int Sig2;				// other 4 byte
	unsigned int Version;			// Number of Field (1byte)
};

// packet contents information structure
struct OSPP_Contents_Info
{
	char QR_Type[QR_TYPE_SIZE + 1];
	int Req_Process;
	int Num_Field;
	int Field_Len[13];
	int Check_Sum;
};

// packet contents structure
struct OSPP_Contents
{
	char* data;						// data (Num of Field items)
};

typedef struct _BUF
{
	OSPP_Header header;
	OSPP_Contents_Info info;
	OSPP_Contents data;
} XBUF, *LPXBUF;

// Message constants
#define HDRSIZE      sizeof(OSPP_Header)    // Size of Message header
#define REALLEN(x)   lstrlen(x) + 1    // REALLEN will now count terminating NULL of x


//ADP

// Analyzing - divide header and contents
int Analyze(char* buffer, OSPP_Header** header, 
			OSPP_Contents_Info,OSPP_Contents& contents);
// Decoding
void Decode(OSPP_Contents& contents);

// Processing
bool Packet_Process(OSPP_Header *header, OSPP_Contents_Info& Contetnts_Info, 
					OSPP_Contents &contents, SOCKET c_sok, char *Buffer);
