
#include "osp_mClass.h"
#include "ospTreeView.h"
#include "osp_global.h"

//static SessionNum=100;

WNDPROC OldTreeProc;
LRESULT CALLBACK TreeSubProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

ospTreeView::ospTreeView()
{
//	InitCommonControls();
	State	=	OTV_NOT_INIT;
	use		=	0;
}

ospTreeView::ospTreeView(HINSTANCE G_hInst,HWND G_hWnd)
{
//	InitCommonControls();
	hInst	=	G_hInst;
	hParent	=	G_hWnd;
	State	=	OTV_INIT_READY;
	use		=	0;
}

ospTreeView::~ospTreeView()
{

}

void ospTreeView::Create()
{
	if(State==OTV_INIT_READY)
	{
		hTree=CreateWindow(WC_TREEVIEW, "",
			WS_CHILD | WS_VISIBLE | WS_BORDER |
			TVS_HASBUTTONS | TVS_LINESATROOT | TVS_HASLINES,
			10,10,100,200,
			hParent,NULL,hInst,NULL);
		State = OTV_WIND_NOIMG;

		////// Ŭ Ÿ 
		LONG style;
		style=GetClassLong(hTree,GCL_STYLE);
		style |= CS_DBLCLKS;
		SetClassLong(hTree,GCL_STYLE,style);

		//////  Ŭ
		OldTreeProc=(WNDPROC)SetWindowLong(hTree,GWL_WNDPROC,(LONG)TreeSubProc);

		use=1;
	}
}

LRESULT CALLBACK TreeSubProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HWND hTree;
	HTREEITEM ti;
	TVITEMEX tvi;
//	TVHITTESTINFO hi;
//	TVHITTESTINFO cmp;
//	cmp.flags=TVHT_ONITEM;
	char fid[30];
	
	switch(msg)
	{
	case WM_LBUTTONDBLCLK:
//		hTree=khos.mainTree->GetTreeHandle();
		hTree=hWnd;
		ti=TreeView_GetSelection(hTree);
		tvi.mask=TVIF_IMAGE|TVIF_TEXT;
		tvi.pszText=fid;
		tvi.hItem=ti;
		tvi.cchTextMax=30;
		TreeView_GetItem(hTree,&tvi);
//		TreeView_HitTest(hTree,&hi);
//		if(hi.hItem!=NULL || !(hi.flags^cmp.flags))
		if(tvi.iImage>3)
		{
			khos.dlg_Chat_Command_dblk(tvi.pszText);
		}
		break;
	case WM_SETFOCUS:
		break;
	}
	return CallWindowProc(OldTreeProc,hWnd,msg,wParam,lParam);
}

void ospTreeView::Create(HINSTANCE hi, HWND hw)
{
	if(State==OTV_NOT_INIT)
	{
		hInst=hi;
		hParent=hw;
		State=OTV_INIT_READY;
	}
		hTree=CreateWindow(WC_TREEVIEW, "",
			WS_CHILD | WS_VISIBLE | WS_BORDER |
			TVS_HASBUTTONS | TVS_LINESATROOT | TVS_HASLINES,
			10,10,100,200,
			hParent,NULL,hInst,NULL);
		State = OTV_WIND_NOIMG;
		use = 1;
}	

void ospTreeView::InitImage(LPCSTR lpbmp)
{
	if(State==OTV_WIND_NOIMG)
	{
	hImage=ImageList_LoadBitmap(hInst,
		lpbmp,16,1,RGB(255,0,255));
	SendMessage(hTree,TVM_SETIMAGELIST,
		(WPARAM)TVSIL_NORMAL,(LPARAM)hImage);
	State=OTV_USE;
	}
}

void ospTreeView::SetPos(RECT pos)
{
	if(State&&use)
	MoveWindow(hTree,pos.left,pos.top,
		pos.right,pos.bottom,TRUE);
}

void ospTreeView::SetPos(int left,int top,int right,int bottom)
{
	if(State&&use)
	MoveWindow(hTree,left,top,
		right,bottom,TRUE);
}

 
///////////////////////////////////////////////////////
// Find Func

HTREEITEM ospTreeView::FindGroup(const char *name)
{
	TVITEM tvi;
	char str[128];

	tvi.mask=TVIF_TEXT;
	tvi.pszText=str;
	tvi.cchTextMax=sizeof(str);
//	tvi.hItem=TreeView_GetRoot(hTree); //Ʈ ڵ 
	tvi.hItem=TreeView_GetChild(hTree,hRoot);
	while(tvi.hItem!=NULL) { //
		TreeView_GetItem(hTree, &tvi);
		if(!strcmp(str,name)) return tvi.hItem;
		tvi.hItem=TreeView_GetNextSibling(hTree,tvi.hItem);
	}
	return NULL;
}

HTREEITEM ospTreeView::FindChild(const char * group,const char *name)
{
	TVITEM tvi;
	char str[128];

	tvi.mask=TVIF_TEXT;
	tvi.pszText=str;
	tvi.cchTextMax=sizeof(str);
	tvi.hItem=FindGroup(group); 
	tvi.hItem=TreeView_GetChild(hTree,tvi.hItem);

	while(tvi.hItem!=NULL) { 
		TreeView_GetItem(hTree, &tvi);
		if(!strcmp(str,name)) return tvi.hItem;
		tvi.hItem=TreeView_GetNextSibling(hTree,tvi.hItem);
	}
	return NULL;
}

HTREEITEM ospTreeView::FindChildAll(const char * group, const char * name)
{
	TVITEM tvi;
	char str[128];

	tvi.mask=TVIF_TEXT | TVIF_IMAGE;
	tvi.pszText=str;
	tvi.cchTextMax=sizeof(str);

	//try to find Friend under the root first
	tvi.hItem=FindGroup(name); 
	if(tvi.hItem)
	{
		TreeView_GetItem(hTree,&tvi);
		if(tvi.iImage>3)
		return tvi.hItem;
	}

	//try to find Friend under the group second
	tvi.hItem=FindGroup(group);
	tvi.hItem=TreeView_GetChild(hTree,tvi.hItem);

	while(tvi.hItem!=NULL) { 
		TreeView_GetItem(hTree, &tvi);
		if(!strcmp(str,name)) return tvi.hItem;
		tvi.hItem=TreeView_GetNextSibling(hTree,tvi.hItem);
	}
	return NULL;
}

bool ospTreeView::FindGroupExist(const char * group)
{
	if(FindGroup(group)) return true;
	else return false;
}


///////////////////////////////////////////////////////
// Insert Func

void ospTreeView::InsertRoot(char * root)
{
	TVINSERTSTRUCT ti;
	
	ti.hParent = 0;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT | TVIF_IMAGE;
	ti.item.pszText=root;
	ti.item.iImage=0;
	
	hRoot=(HTREEITEM)SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
}

void ospTreeView::InsertGroup(char * group)
{
	if(FindGroup(group)==NULL)
	{
	HTREEITEM node;
	TVINSERTSTRUCT ti;
	
	ti.hParent = hRoot;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT;
	ti.item.pszText=group;
	
	node=(HTREEITEM)SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
	}
}

void ospTreeView::InsertGroup(char * group,int img)
{
	if(FindGroup(group)==NULL)
	{
	HTREEITEM node;
	TVINSERTSTRUCT ti;
	
	ti.hParent = hRoot;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT | TVIF_IMAGE;
	ti.item.pszText=group;
	ti.item.iImage=img;
	
	node=(HTREEITEM)SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
	}
}

void ospTreeView::InsertChild(char * child)
{
	HTREEITEM node;
	TVINSERTSTRUCT ti;
	
	ti.hParent = 0;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT;
	ti.item.pszText=child;
	
	node=(HTREEITEM)SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
}

void ospTreeView::InsertChild(char * child,int img)
{
	HTREEITEM node;
	TVINSERTSTRUCT ti;
	
	ti.hParent = 0;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT| TVIF_IMAGE;
	ti.item.pszText=child;
	ti.item.iImage=img;
	
	node=(HTREEITEM)SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
}

void ospTreeView::InsertChild(HTREEITEM parent,char * child)
{
	TVINSERTSTRUCT ti;
	
	ti.hParent = parent;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT;
	ti.item.pszText=child;
	
	SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
}

void ospTreeView::InsertChild(HTREEITEM parent,char * child,int img)
{
	TVINSERTSTRUCT ti;
	
	ti.hParent = parent;
	ti.hInsertAfter = TVI_LAST;
	ti.item.mask= TVIF_TEXT | TVIF_IMAGE;
	ti.item.pszText=child;
	ti.item.iImage=img;
	
	SendMessage(hTree,TVM_INSERTITEM,0,
		(LPARAM)(LPTV_INSERTSTRUCT)&ti);
}

void ospTreeView::InsertChild(const char* group, char* child)
{
	HTREEITEM ti;
	ti=FindGroup(group);
	InsertChild(ti,child);
}

void ospTreeView::InsertChild(const char* group, char* child,int img)
{
	HTREEITEM ti;
	ti=FindGroup(group);
	InsertChild(ti,child,img);
}

///////////////////////////////////////////////////////
// Delete Func


void ospTreeView::DeleteGroup(const char * group)
{
	HTREEITEM ti;

	ti=FindGroup(group);

	if(ti!=NULL)
		TreeView_DeleteItem(hTree,ti);
}// ۵ ...ؾ

void ospTreeView::DeleteChild(const char * group,const char * child)
{
	HTREEITEM ti;
	ti=FindChild(group,child);

	if(ti!=NULL)
		TreeView_DeleteItem(hTree,ti);

}//ſ  ۵.

void ospTreeView::DeleteChild(const char * child)
{
	HTREEITEM ti;
	ti=FindChildAll(NULL,child);

	if(ti!=NULL)
		TreeView_DeleteItem(hTree,ti);

}

void ospTreeView::DeleteAll()
{
	TreeView_DeleteAllItems(hTree);
}//̻ .

///////////////////////////////////////////////////////
// Modify Func

void ospTreeView::ModifyChild(const HTREEITEM fti,int state)
{
	TVITEM tvi;
	tvi.hItem=fti;
	tvi.mask = TVIF_IMAGE;
	TreeView_GetItem(hTree,&tvi);
	tvi.iImage=state;
	TreeView_SetItem(hTree,&tvi);
}

///////////////////////////////////////////////////////
// MISC Func

HWND ospTreeView::GetTreeHandle()
{
	return hTree;
}

bool ospTreeView::IsChildNode()
{
	TVITEM tvi;
	tvi.mask=TVIF_IMAGE;
	tvi.hItem=TreeView_GetSelection(hTree);

	if(tvi.hItem)
	{
		TreeView_GetItem(hTree,&tvi);
		if(tvi.iImage>3)
		return true;
		else 
			return false;
	}
	return false;
}

