
#include "../osp_mClass.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"
#include "osp_sup_ChatEdit.h"

//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK Chat(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgChatInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgChatCommand(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgChatClose(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdChatOk(HWND, WORD, WORD, HWND);
LRESULT CmdChatCancel(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsdChat[] =
{
    {WM_COMMAND,        MsgChatCommand},
    {WM_INITDIALOG,     MsgChatInit},
	{WM_CLOSE,			MsgChatClose}
};

MSDI msdiChat =
{
    sizeof(rgmsdChat) / sizeof(MSD),
    rgmsdChat,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdChat[] =
{
    {IDOK,			CmdChatOk},
	{IDCANCEL,		CmdChatCancel}
};

CMDI cmdiChat =
{
    sizeof(rgcmdChat) / sizeof(CMD),
    rgcmdChat,
    edwpNone
};

//HWND hEdit;

LRESULT CALLBACK Chat(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiChat, hdlg, msg, wparam, lparam);
}

LRESULT MsgChatInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	char Temp[30];
/*	RECT rc;
	GetWindowRect(hdlg,&rc);
	MoveWindow(hdlg,rc.right/2+300,rc.bottom/2,280,365,true);
*/	Session_Record sr;

	if(khos.Session.findSession((int)lparam,sr)==2)
	{
		khos.dlg_Debug_Log_Show("InChat:Founded Session");
		wsprintf(Temp,"%s԰ ȭ", sr.FID);	
		if(!SetWindowText(hdlg,Temp))
			khos.dlg_Debug_Log_Show("Set Text Succeeed.");

		sr.hCDlg=hdlg;
		sr.hChatList=GetDlgItem(hdlg,IDC_CHAT_LIST);
		sr.state=1;
		khos.Session.modifySession(lparam,sr);	

		CreateChatEdit(khos.g_hinst,hdlg,(HMENU)13,sr);
		ShowWindow(hdlg,SW_SHOW);
//		SetFocus(hdlg);
	}
	ShowWindow(hdlg,SW_SHOW);
    return (TRUE);
}

LRESULT MsgChatCommand(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiChat, hwnd, wparam, lparam);
}

LRESULT MsgChatClose(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
	HWND hList;
	Session_Record sr;
	hList=GetDlgItem(hwnd,IDC_CHAT_LIST);
	if(khos.Session.findSession(hList,sr)==2)
	{
		khos.Session.deleteSession(sr.myDlgID);
//		MessageBox(hwnd,"Deleted Session","Alert",MB_OK);
	    DestroyWindow(hwnd);
		return 0;
	}
//	else MessageBox(hwnd,"ã","Alert",MB_OK);
    return 0;
}

LRESULT CmdChatOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    SendMessage(hdlg,WM_CLOSE,0,0);
    return TRUE;
}

LRESULT CmdChatCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    SendMessage(hdlg,WM_CLOSE,0,0);
    return TRUE;
}
