
//	osp-project
//
//  MODULE:   osp_dlg_connect.cpp
//

#include "../osp_mClass.h"
#include <winsock2.h>
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"
#include "../osp_net_global.h"


//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK Connect(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgConnectInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgConnectCommand(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdConnectNow(HWND, WORD, WORD, HWND);
LRESULT CmdConnectDone(HWND, WORD, WORD, HWND);

//not used
LRESULT CmdConnectEnableOK(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsdConnect[] =
{
    {WM_COMMAND,        MsgConnectCommand},
    {WM_INITDIALOG,     MsgConnectInit},
};

MSDI msdiConnect =
{
    sizeof(rgmsdConnect) / sizeof(MSD),
    rgmsdConnect,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdConnect[] =
{
    {IDOK,				CmdConnectNow},
    {IDCANCEL,			CmdConnectDone},
    {IDC_USER_ID,		CmdConnectEnableOK},
    {IDC_USER_PASSWD,	CmdConnectEnableOK}
};

CMDI cmdiConnect =
{
    sizeof(rgcmdConnect) / sizeof(CMD),
    rgcmdConnect,
    edwpNone
};

LRESULT CALLBACK Connect(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiConnect, hdlg, uMessage, wparam, lparam);
}

LRESULT MsgConnectInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{

	khos.dlg_LogDlg_Init(hdlg);

    // Center the dialog over the application window
    CenterWindow (hdlg, GetWindow (hdlg, GW_OWNER));


    // Limit size of edit controls
    SendDlgItemMessage(hdlg, IDC_USER_ID, EM_LIMITTEXT, 8, 0);
    // Limit size of edit controls
    SendDlgItemMessage(hdlg, IDC_USER_PASSWD, EM_LIMITTEXT, 6, 0);

    // Initialize Edit Controls
    SetDlgItemText(hdlg, IDC_USER_ID, "");
    // Initialize Edit Controls
    SetDlgItemText(hdlg, IDC_USER_PASSWD, "");
	
	SetFocus((HWND)IDC_USER_ID);

    return (TRUE);
}


LRESULT MsgConnectCommand(HWND   hwnd,
                          UINT   uMessage,
                          WPARAM wparam,
                          LPARAM lparam)
{
    return DispCommand(&cmdiConnect, hwnd, wparam, lparam);
}


LRESULT CmdConnectDone(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	khos.net_TryDisconnect();

    HMENU hmenu;
    // Fix menus
    hmenu = GetMenu(g_hwnd);
    EnableMenuItem(hmenu, IDM_DISCONNECT, MF_GRAYED);
    EnableMenuItem(hmenu, IDM_CONNECT, MF_ENABLED);

    EndDialog(hdlg, FALSE);        // Exit Dialog -- rtrn false since no connection
    return TRUE;
}


LRESULT CmdConnectNow(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	khos.net_TryConnect();
    EndDialog(hdlg, TRUE);          // Exit the dialog
	return 0;

}

LRESULT CmdConnectEnableOK(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char id[11];
	char pass[11];
	GetDlgItemText(hdlg,IDC_USER_ID,id,10);
	GetDlgItemText(hdlg,IDC_USER_PASSWD,pass,10);

	if(wNotify == EN_CHANGE)
	{
		if(strcmp(id,"") && strcmp(pass,""))
			EnableWindow(GetDlgItem(hdlg,IDOK),TRUE);
		else
			EnableWindow(GetDlgItem(hdlg,IDOK),FALSE);
	}
	return TRUE;
}
