
#include "../osp_mClass.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>
#include <commctrl.h>
// DO link ComCtl32.lib file your project...

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"


#include "../ospTreeView.h"

//   Function Definitions
void SetTransparent(HWND hWnd, BYTE byTrans);

//	Main Callback Fuction
LRESULT CALLBACK Option(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgOptionInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgOptionCommand(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgOptionScroll(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgOptionNotify(HWND, UINT, WPARAM, LPARAM);
//	Command Function
LRESULT CmdOptionOk(HWND, WORD, WORD, HWND);
LRESULT CmdOptionCancel(HWND, WORD, WORD, HWND);
// Connect dialog message table definition.
MSD rgmsdOption[] =
{
	{WM_INITDIALOG,     MsgOptionInit},
    {WM_COMMAND,        MsgOptionCommand},
    {WM_HSCROLL,		MsgOptionScroll},
	{WM_NOTIFY,			MsgOptionNotify}
};

MSDI msdiOption =
{
    sizeof(rgmsdOption) / sizeof(MSD),
    rgmsdOption,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdOption[] =
{
    {IDOK,			CmdOptionOk},
	{IDCANCEL,		CmdOptionCancel}
};

CMDI cmdiOption =
{
    sizeof(rgcmdOption) / sizeof(CMD),
    rgcmdOption,
    edwpNone
};

//////////////////////////////////////////////////////
// FUNC
//LRESULT CALLBACK ServProc(HWND,UINT,WPARAM,LPARAM);
//LRESULT CALLBACK TranProc(HWND,UINT,WPARAM,LPARAM);
void option_server_show(HWND,int);
void option_tran_show(HWND hdlg,int type);
void SetTransparent(HWND hWnd, BYTE byTrans);

//////////////////////////////////////////////////////
// VARIABLE
//HWND hserv, hTran
HWND hTrack, hParent;
int Trans;

LRESULT CALLBACK Option(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiOption, hdlg, uMessage, wparam, lparam);
}

//۾ : 130,10,180,100
LRESULT MsgOptionInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	khos.optionTree=new ospTreeView();
	khos.optionTree->Create(g_hinst,hdlg);
	khos.optionTree->InitImage(MAKEINTRESOURCE(IDB_STATE));
	khos.optionTree->InsertRoot("Option");
	khos.optionTree->SetPos(10,10,110,130);
	khos.optionTree->InsertGroup("",44);
	khos.optionTree->InsertGroup("",19);


//	InitCommonControls();
	hTrack = GetDlgItem(hdlg, IDC_OPTION_SLIDER_TRAN);
	hParent = GetParent(hdlg);
	Trans = 255;
	SendMessage(hTrack, TBM_SETRANGE, FALSE, MAKELPARAM(0, 255));
	SendMessage(hTrack, TBM_SETPOS, FALSE, Trans);
	SetDlgItemInt(hdlg, IDC_OPTION_EDIT_TRAN, Trans, FALSE);

	return (TRUE);
}

LRESULT MsgOptionCommand(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiOption, hwnd, wparam, lparam);
}

LRESULT MsgOptionScroll(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	if ((HWND)lparam == hTrack)	{
		Trans = SendMessage(hTrack, TBM_GETPOS, 0, 0);
		SetDlgItemInt(hdlg, IDC_OPTION_EDIT_TRAN, Trans, FALSE);
		SetTransparent(hParent, Trans);
	}
	return (TRUE);
}

LRESULT MsgOptionNotify(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	LPNMHDR		hdr;
	LPNMTREEVIEW	ntv;
	hdr=(LPNMHDR)lparam;
	ntv=(LPNMTREEVIEW)lparam;
	char cap[30];

	TVITEMEX tvex;

	if(hdr->hwndFrom == khos.optionTree->GetTreeHandle())
	{
		switch(hdr->code)
		{
		case TVN_SELCHANGED:
			tvex.mask=TVIF_TEXT|TVIF_PARAM;
			tvex.pszText=cap;
			tvex.cchTextMax=30;
			tvex.hItem=ntv->itemNew.hItem;
			TreeView_GetItem(khos.optionTree->GetTreeHandle(),&tvex);
			if(!strcmp("",tvex.pszText))
			{
				option_tran_show(hdlg,0);
				option_server_show(hdlg,1);
			}
			else if(!strcmp("",tvex.pszText))
			{
				option_server_show(hdlg,0);
				option_tran_show(hdlg,1);
			}
			break;
		}
	}
	return (TRUE);
}


LRESULT CmdOptionOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	//server setting
	char server[24];
	char joinserv[24];
	GetDlgItemText(hdlg,IDC_OPTION_EDIT_SERVER,
		server,23);
	GetDlgItemText(hdlg,IDC_OPTION_EDIT_SERVER2,
		joinserv,23);
	if(strcmp(server,""))
		khos.dlg_Option_SetServer(server);
	if(strcmp(joinserv,""))
		khos.dlg_Option_SetJoinServer(joinserv);

	//set Trans
	Trans = GetDlgItemInt(hdlg, IDC_OPTION_EDIT_TRAN, NULL, FALSE);
	SetTransparent(hParent, Trans);
	EndDialog(hdlg, TRUE);
    return TRUE;
}

LRESULT CmdOptionCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	delete khos.optionTree;
    EndDialog(hdlg, FALSE);
    return TRUE;
}

/*
LRESULT CALLBACK ServProc(HWND hdlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
	return (DefWindowProc(hdlg,msg,wParam,lParam));
}
LRESULT CALLBACK ServProc(HWND hdlg,UINT msg,WPARAM wParam,LPARAM lParam)
{
	return (DefWindowProc(hdlg,msg,wParam,lParam));
}
*/

void option_server_show(HWND hdlg,int type)
{
	HWND Text,Edit;
	HWND Text2,Edit2;
	Text=GetDlgItem(hdlg,IDC_OPTION_TEXT_SERVER);
	Edit=GetDlgItem(hdlg,IDC_OPTION_EDIT_SERVER);
	Text2=GetDlgItem(hdlg,IDC_OPTION_TEXT_SERVER2);
	Edit2=GetDlgItem(hdlg,IDC_OPTION_EDIT_SERVER2);
	if(type)
	{
		ShowWindow(Text,SW_SHOW);
		ShowWindow(Edit,SW_SHOW);
		ShowWindow(Text2,SW_SHOW);
		ShowWindow(Edit2,SW_SHOW);
	}
	else
	{
		ShowWindow(Text,SW_HIDE);
		ShowWindow(Edit,SW_HIDE);
		ShowWindow(Text2,SW_HIDE);
		ShowWindow(Edit2,SW_HIDE);
	}		
}

void option_tran_show(HWND hdlg,int type)
{
	HWND Text,Edit,Slider,Group;
	Text=GetDlgItem(hdlg,IDC_OPTION_TEXT_TRAN);
	Edit=GetDlgItem(hdlg,IDC_OPTION_EDIT_TRAN);
	Slider=GetDlgItem(hdlg,IDC_OPTION_SLIDER_TRAN);
	Group=GetDlgItem(hdlg,IDC_OPTION_GROUP_TRAN);
	if(type)
	{
		ShowWindow(Text,SW_SHOW);
		ShowWindow(Edit,SW_SHOW);
		ShowWindow(Slider,SW_SHOW);
		ShowWindow(Group,SW_SHOW);
	}
	else
	{
		ShowWindow(Text,SW_HIDE);
		ShowWindow(Edit,SW_HIDE);
		ShowWindow(Slider,SW_HIDE);
		ShowWindow(Group,SW_HIDE);
	}		

}

void SetTransparent(HWND hWnd, BYTE byTrans)
{
	typedef BOOL (WINAPI *pfnSLWA)(HWND hWnd, COLORREF, BYTE, DWORD);

	pfnSLWA fnSLWA;
	DWORD dwExStyle;
	HINSTANCE hInstance;

	if((hInstance = LoadLibrary("user32.dll")) == NULL) return;

	fnSLWA = (pfnSLWA)GetProcAddress(hInstance, "SetLayeredWindowAttributes");
	if(fnSLWA)
	{
		dwExStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
		if(byTrans == 0xff) dwExStyle &= ~0x00080000;
		else				dwExStyle |= 0x00080000;
		SetWindowLong(hWnd, GWL_EXSTYLE, dwExStyle);
		fnSLWA(hWnd, 0, byTrans, 0x00000002);
	}

	FreeLibrary(hInstance);
}
