

#include "osp_Dispatch.h"


//-------------------------------------------------------------------------
// Functions for handling main window messages.  The message-dispatching
// mechanism expects all message-handling functions to have the following
// prototype:
//
//     LRESULT FunctionName(HWND, UINT, WPARAM, LPARAM);

LRESULT MsgCreate(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgSize(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgSetfocus(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgCommand(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDataready(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgRefreshdisplay(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDisconnected(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDestroy(HWND, UINT, WPARAM, LPARAM);


//-------------------------------------------------------------------------
// Functions for handling main window commands--ie. functions for
// processing WM_COMMAND messages based on the wParam value.
// The message-dispatching mechanism expects all command-handling
// functions to have the following prototype:
//
//     LRESULT FunctionName(HWND, WORD, WORD, HWND);

LRESULT CmdConnect(HWND, WORD, WORD, HWND);
LRESULT CmdSelect(HWND, WORD, WORD, HWND);
LRESULT CmdExit(HWND, WORD, WORD, HWND);
LRESULT CmdAbout(HWND, WORD, WORD, HWND);
LRESULT CmdOutbox(HWND, WORD, WORD, HWND);
LRESULT CmdDisconnect(HWND, WORD, WORD, HWND);
LRESULT CmdEndChat(HWND, WORD, WORD, HWND);

//	Tray command func

LRESULT CmdTray1(HWND, WORD, WORD, HWND);
LRESULT CmdTray2(HWND, WORD, WORD, HWND);
LRESULT CmdTray3(HWND, WORD, WORD, HWND);
LRESULT CmdTrayExit(HWND, WORD, WORD, HWND);

//-------------------------------------------------------------------------
// User Defined Messages.  These definitions are used for indicating
// network events.

#define MW_DATAREADY       501
#define MW_DISPLAYREFRESH  502
#define MW_DISCONNECTED    503
#define LDM_CONNECTED      504

//#endif

#ifndef OSP_WIN_CMD
// Main window message table definition.
MSD rgmsd[] =
{
    {WM_CREATE,         MsgCreate},
    {WM_SIZE,           MsgSize},
    {WM_SETFOCUS,       MsgSetfocus},
    {WM_COMMAND,        MsgCommand},
    {WM_DESTROY,        MsgDestroy},
    {MW_DATAREADY,      MsgDataready},
    {MW_DISCONNECTED,   MsgDisconnected},
    {MW_DISPLAYREFRESH, MsgRefreshdisplay}
};

MSDI msdiMain =
{
    sizeof(rgmsd) / sizeof(MSD),
    rgmsd,
    edwpWindow
};
#endif

#ifndef OSP_WIN_PROC
// Main window command table definition.
//   ޴ 
CMD rgcmd[] =
{
//  {IDM_CONNECT,           CmdConnect}, 
//  {IDM_SELECT,            CmdSelect},
    {IDM_EXIT,              CmdExit},
//  {IDM_ABOUT,             CmdAbout},
    {ID_OUTBOX,             CmdOutbox},
    {IDM_DISCONNECT_SERVER, CmdDisconnect},
    {IDM_END_CHAT,          CmdEndChat},

//	Tray command
	{ID_TRAY_MENU1,			CmdTray1},
	{ID_TRAY_MENU2,			CmdTray2},
	{ID_TRAY_MENU3,			CmdTray3},
	{ID_TRAY_MENU_EXIT,		CmdTrayExit},
};

CMDI cmdiMain =
{
    sizeof(rgcmd) / sizeof(CMD),
    rgcmd,
    edwpWindow
};

#endif