
//	osp-project
//
//  MODULE:   osp_win_proc.cpp

#ifndef OSP_WIN_PROC
#define OSP_WIN_PROC

#include "osp_win_proc.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>


#include "../osp_global.h"


//   ν
LRESULT CALLBACK WndProc(HWND   hwnd,
                         UINT   uMessage,
                         WPARAM wparam,
                         LPARAM lparam)
{
	Tray.TrayInit(g_hinst,hwnd,0);
    return DispMessage(&msdiMain, hwnd, uMessage, wparam, lparam);
}

//WM_CREATE
// ʱȭ ڵ
LRESULT MsgCreate(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	int x,y;
	x   =GetPrivateProfileInt("position","left",500,"khos.ini");
	y   =GetPrivateProfileInt("position","top",200,"khos.ini");
	
	if(x>800 || y>500) 
	{
		x=500;y=200;
	}
	MoveWindow(hwnd,x,y,250,300,true);
	if (!Tray.CreateIcon(TRAY_NOTIFY, "Tray test", LoadIcon(g_hinst, MAKEINTRESOURCE(IDI_ICON_OS))))
	{
		return 1;
	}

	khos.khos_Initialize(g_hinst,hwnd);
	khos.mainTree=new ospTreeView(g_hinst,hwnd);
	khos.mainTree->Create();
	khos.mainTree->InitImage(MAKEINTRESOURCE(IDB_STATE));
	khos.mainTreeState=1;
	SendMessage(hwnd,WM_PAINT,0,0);
	
//	SessionTest();
    return (TRUE);
}

LRESULT MsgPaint(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	HDC hdc,MemDC;
	PAINTSTRUCT ps;
	HBITMAP		ospBackImg,oldImg;
	RECT rc;
	GetClientRect(hwnd,&rc);
	RECT textrc={rc.left+40,(rc.bottom/2-40),rc.right-40,(rc.bottom/2)};
	HBRUSH brush,oldbrush;
	char login[]="α ϼ.";

	hdc=BeginPaint(hwnd,&ps);

	MemDC=CreateCompatibleDC(hdc);
	ospBackImg=LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_BACKIMG));
	oldImg=(HBITMAP)SelectObject(MemDC,ospBackImg);
	StretchBlt(hdc,0,0,rc.right,rc.bottom,MemDC,0,10,11,280,SRCCOPY);
	DeleteObject(ospBackImg);
	DeleteDC(MemDC);

	if(!khos.Get_khos_state())
	{
		ShowWindow(khos.mainTree->GetTreeHandle(),SW_HIDE);
		brush=(HBRUSH)GetStockObject(WHITE_BRUSH);
		oldbrush=(HBRUSH)SelectObject(hdc,brush);
		Rectangle(hdc,rc.left+40,(rc.bottom/2-50),rc.right-40,(rc.bottom/2-20));
		SelectObject(hdc,oldbrush);
		DrawText(hdc,login,-1,&textrc,DT_CENTER );
	}
	EndPaint(hwnd,&ps);	

	return 0;
}


LRESULT MsgSize(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	RECT rc;
	GetClientRect(hwnd,&rc);

	if(khos.mainTreeState)
	khos.mainTree->SetPos(rc.left+20,rc.top+40,rc.right-40,rc.bottom-80);
    return (TRUE);
}

LRESULT MsgTimer(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	if(khos.mainTreeState)
	khos.net_SendData(1007);//see osp_mClass.h query for friend list
	return (TRUE);
}


LRESULT MsgSetfocus(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
//    SetFocus(hOutWnd);  // Don't let main window have focus
    return (TRUE);
}

LRESULT MsgChat(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	khos.dlg_Chat_Command(lparam);
	return 0;
}	

LRESULT MsgStandby(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{

	return 0;
}	


LRESULT MsgDataready(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	ShowWindow(khos.mainTree->GetTreeHandle(),SW_SHOW);
	khos.mainTree->InsertRoot("Friend List");
    return(TRUE);
}


LRESULT MsgRefreshdisplay(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	/*
    MSG peekmsg;

    // Don't bother displaying if there is already another update queued
    if(PeekMessage(&peekmsg, hwnd, MW_DATAREADY, MW_DISPLAYREFRESH, PM_NOREMOVE))
    {
       return(TRUE);
    }
    // Put data in szRcvBuf in InBox
    SendDlgItemMessage(hwnd,
                       ID_INBOX,
                       EM_SETSEL,
                       0,-1);
    SendDlgItemMessage(hwnd,
                       ID_INBOX,
                       EM_REPLACESEL,
                       0,
                       (LPARAM)szRcvBuf);
					   */
    return(TRUE);
}


LRESULT MsgDisconnected(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	ShowWindow(khos.mainTree->GetTreeHandle(),SW_HIDE);
	SendMessage(hwnd,WM_PAINT,0,0);
    SetWindowText(hwnd, szTitle);
    return(TRUE);
}


LRESULT MsgCommand(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiMain, hwnd, wparam, lparam);
}


LRESULT MsgDestroy(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	RECT rt;
	char buf[10];
	GetWindowRect(hwnd,&rt);
	itoa(rt.left,buf,10);
	WritePrivateProfileString("position","left",buf,"khos.ini");
	itoa(rt.top,buf,10);
	WritePrivateProfileString("position","top",buf,"khos.ini");

	Tray.DeleteIcon();
    PostQuitMessage(0);
    return 0;
}

LRESULT MsgTrayProcess(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
		if(!Tray.TrayProcess(lparam))
		{
			return 1;
		}
	return 0;
}


#endif
