// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Jaguar.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_View = NULL;	
	m_LoginView = NULL;
	m_session = new CSession;
}

CMainFrame::~CMainFrame()
{
	if(m_session)
		delete m_session;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.cx=370;
	cs.cy=500;
	
	cs.x=400;
	cs.y=100;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::CreateNewView()
{
	m_LoginView = (CLoginView *)GetActiveView();
	
	if(m_View == NULL)
	{
		m_View = new CMainView;
		
		CCreateContext context;
		context.m_pCurrentDoc = (CDocument* )m_LoginView->GetDocument();
		m_View->Create(NULL,NULL,0L,CFrameWnd::rectDefault,this,IDW_LOGIN_VIEW,&context);
		m_View->OnInitialUpdate(); 
		
//		m_View->SetJaguarSession(m_Session);
//		m_JaguarSession->SetJaguarView(m_View);
	}

}

void CMainFrame::ChangeView(int nForm)
{
	if(nForm == IDW_LOGIN_VIEW){
		SetActiveView(m_View);
//		m_View->OnActive();
		m_View->ShowWindow(SW_SHOW);
		m_LoginView->ShowWindow(SW_HIDE);
		m_View->SetDlgCtrlID(AFX_IDW_PANE_FIRST);
		m_LoginView->SetDlgCtrlID(IDW_MAIN_VIEW);
		
	}else if(nForm == IDW_MAIN_VIEW){
		SetActiveView(m_LoginView);
//		m_LoginView->OnActive();
		m_LoginView->ShowWindow(SW_SHOW);
		m_View->ShowWindow(SW_HIDE);
		m_LoginView->SetDlgCtrlID(AFX_IDW_PANE_FIRST);
		m_View->SetDlgCtrlID(IDW_LOGIN_VIEW);
	}
	
//	RecalcLayout();
}

CSession * CMainFrame::getSession()
{
	return m_session;
}

