
#include "JaguarX.h"
#include "JaguarEx.h"


//  
//   Ÿ ʱȭ Ѵ.
Agent::Agent(const Agent& a)
     : _session(a._session), _jid(a._jid), _name(a._name),
       _desc(a._desc), _service(a._service), _transport(a._transport),
       _registerable(a._registerable), _searchable(a._searchable),
       _subagents(a._subagents)
{
     if (_name.empty())
	  _name = "No name available (" + a._jid + ")";
}

// JID xml,  ʱȭ Ѵ.
Agent::Agent(const string& jid, const Element& baseElement, JSession& s)
     : _jid(jid), _session(s)
{
     _name      = baseElement.getChildCData("name");
     _desc      = baseElement.getChildCData("description");
     _service   = baseElement.getChildCData("service");
     _transport = baseElement.getChildCData("transport");
     _registerable   = (baseElement.findElement("register") != NULL);
     _searchable     = (baseElement.findElement("search") != NULL);
     _subagents      = (baseElement.findElement("agents") != NULL);
     _gc_capable     = (baseElement.findElement("groupchat") != NULL);
     _fetchrequested = false;
}

Agent::~Agent()
{}


// khos_remake
//  queryNamespace ߵǾ  𸣰ڴ.
//void Agent::requestRegister(ElementCallbackFunc f)
void Agent::requestRegister(SigFuncElement &s)
{
//     _session.queryNamespace("jabber:iq:register", f, _jid);
     _session.queryNamespace("jabber:iq:register", s , _jid);
}

// khos_remake
//  queryNamespace ߵǾ  𸣰ڴ.
//void Agent::requestSearch(ElementCallbackFunc f)
void Agent::requestSearch(SigFuncElement &s)
{
     _session.queryNamespace("jabber:iq:search",s, _jid);
}

void Callback_on_fetch(JSig * inst,const Element& iq)
{
	inst->on_fetch(iq);
}

// khos_remake : Agent Ŭ List ӹ޾Ҵµ ̸ ߱⿡ 
//				 Ǿ Ѵ.
void Agent::fetch()
{
// khos_error
//     if ( _subagents && empty() && !_fetchrequested )
     {
	  // Release existing agents
// khos_error
//	  clear();
	  // Set the fetch request flag
	  _fetchrequested = true;
	  _session.queryNamespace("jabber:iq:agents", _Sigon_fetch, _jid);
     }
}         

void Agent::on_fetch(const Element& iq)
{
     // Reset fetch request flag
     _fetchrequested = false;

     // IQ should contain an <iq> tag with one child tag <query>; within <query>,
     // there should be 1 or more <agent> tags -- these tags must be parsed into
     // agent objects and stored internally to "this" agent
     const Element* query = iq.findElement("query");
     if (query == NULL)
	  return;

	 // Ÿ resultΰ?
     if (iq.cmpAttrib("type", "result"))
     {
	  // Walk the <query> tag's children
	  Element::const_iterator it = query->begin();
	  for (; it != query->end(); it++)
	  {
	       if ((*it)->getType() != Node::ntElement)
		    continue;
	       // Cast the child element into a tag
	       Element& t = *static_cast<Element*>(*it);
	       
	       // Ensure this is an agent tag
		   // khos_remake : list   ʾұ⿡ 䱸...
	       if (t.getName() == "agent")
		   {
			   // khos_error
//		    push_back(Agent(t.getAttrib("jid"), t, _session));
		   }
	  }

	  // Notify any one-time observers that this agent has been updated successfully
	  evtFetchComplete(true);
     }
     else
     {
	  // Notify any observer that this agent has not been update successfully
	  evtFetchComplete(false);
     }

     // Release all one-time observers
	 // khos_remake :  ؾ  𸣰ڴ.
	 // libsigc++  ü ؼ Լ ͸ ߴµ
	 // ü ŭ    ʱ ̴.
     //evtFetchComplete.clear();
}

AgentList::AgentList(const Element& query, JSession& s)
{
     load(query, s);
}

void AgentList::load(const Element& query, JSession& s)
{
     // Ensure list is clear
     clear();
     // MAke sure this is the proper namespace
     if (!query.cmpAttrib("xmlns", "jabber:iq:agents"))
	  return;

     // Walk each of the child <agent> tags and build agent objects
     Element::const_iterator it = query.begin();
     for (; it != query.end(); it++)
     {
	  if ((*it)->getType() != Node::ntElement)
	       continue;
	  // Cast the child element to a tag
	  Element& t = *static_cast<Element*>(*it);

	  // Ensure this is an <agent> tag
	  if (t.getName() == "agent")
	       // Construct and insert an agent
	       push_back(Agent(t.getAttrib("jid"), t, s));
     }
}

