
#ifndef PRESENCEDB_H
#define PRESENCEDB_H


#include "JaguarX.h"


namespace JaguarX
{


class JPresenceDB
{
public:
		  typedef list<JPresence>::iterator             iterator;
		  typedef list<JPresence>::const_iterator       const_iterator;
		  typedef pair<const_iterator, const_iterator> range;
		  
		  class XCP_InvalidJID : public XCP{};
		  
		  JPresenceDB(JSession& s);
		  public:
			  void           insert(const JPresence& p);
			  void           remove(const string& jid);
			  void		 clear();
			  range          equal_range(const string& jid) const;
			  const_iterator find(const string& jid) const;
			  JPresence       findExact(const string& jid) const;
			  bool           contains(const string& jid) const;
			  bool           available(const string& jid) const;
		  private:
			  typedef map<string, list<JPresence>, jutil::CaseInsensitiveCmp > db;
			  db::const_iterator find_or_throw(const string& jid) const;
			  JSession&   _Owner;
			  db         _DB;
};

}//end of JaguarX namespace


#endif