
#pragma warning(disable:4503)
#pragma warning(disable:4786)


//#include "Roster.h"
#include "Session.h"

namespace JaguarX{

//////////////////////////////////////////////////////////////////////////

JRoster::JRoster(JSession& s)
     : _owner(s)
{}

//  ϴ 𸣰
//  ʿ ͸ jid  ͸ 
const JRoster::Item& JRoster::operator[](const string& jid) const
{
     ItemMap::const_iterator it = _items.find(filterJID(jid));
     if (it == _items.end())
	  throw XCP_InvalidJID();
     else
	  return it->second;
}

//   .
void JRoster::reset()
{
     _items.clear();
}

// ---------------------------------------------------------
// Information
// ---------------------------------------------------------
//  ʿ jid ִ ǴѴ.
bool JRoster::containsJID(const string& jid) const
{
     return (_items.find(filterJID(jid)) != _items.end());
}

// ---------------------------------------------------------
// Update ops
// ---------------------------------------------------------
//  ʿ  Ʈ Ű Լ 
void JRoster::update(const Element& t)
{
     bool updateFlag = false;

     // Process each <item> tag and add/update
     // the JRoster
     Element::const_iterator it = t.begin();
     for (; it != t.end(); ++it )
     {
	  if ((*it)->getType() != Node::ntElement)
	       continue;
	  // Cast item into a tag..
	  Element& item = *static_cast<Element*>(*it);

	  // Extract JID & resource
	  string jid = filterJID(item.getAttrib("jid"));

	  // Lookup this jid in the item map
	  //  ʿ jid ã´.
	  ItemMap::iterator rit = _items.find(jid);

	  // If this jid is already in the Item map, update it...
	  // jid ̹  ʿ  Ʈ Ѵ.
	  if (rit != _items.end())
	  {
	       // If the subscription type = "remove" then, we need
	       // to delete this JRoster item...
	       updateFlag = true;
		   // subscription  remove̸ 
	       if (item.cmpAttrib("subscription", "remove"))
	       {
		    removeItemFromAllGroups(rit->second);
		    _items.erase(rit);
	       }
	       // Otherwise, update the JRoster item
		   // ȯ ʿ  .
	       else
		    rit->second.update(*this, item);

	  }
	  // Otherwise, create a new item on the map
	  //  ʿ  subscription Ÿ remove ƴ 
	  else if (!item.cmpAttrib("subscription", "remove"))
	  {
	       _items.insert(make_pair(jid, Item(*this, item)));
	       updateFlag = true;
	  }
     }
     // Notify whoever we need to that the overall JRoster has been updated
	 // Ʈ    Լ  Ų.
     if (updateFlag)
	 {
		 // khos_debug
		 cout<<"evtRefresh()Լ ȣ....."<<endl;
		//evtRefresh();
	 }

}

//    ޼ ؼ
//   presence Ʈ Ѵ.
void JRoster::update(const JPresence& p, JPresence::Type prev_type)
{
     // Locate the JSession sender on our map
	//޼   Դ ȮѴ.
     string jid = filterJID(p.getFrom());
	 // ʿ  jid ִ ȮѴ.
     ItemMap::iterator it = _items.find(jid);
     if (it != _items.end())
     {
          it->second.update(*this, jid, p, prev_type);             // Update the item
     }
}

/*===================================================
<iq type='set'>
	<query xmlns='jabber:iq:Roster'>
	<item jid='some@host' name='somebody'>
		<group  >
		<group	>
		.......
	</item>
</iq>
===================================================*/
//   Ʈ Ѵ.
//  ޼ .
void JRoster::update(const Item& i)
{
     // Compose basic query packet
     Element iq("iq");
     iq.putAttrib("type", "set");
     Element* query = iq.addElement("query");
     query->putAttrib("xmlns", "jabber:iq:Roster");
     Element* item = query->addElement("item");

     // Insert item specifics
     item->putAttrib("jid", i.getJID());
     if (!i.getNickname().empty())
	  item->putAttrib("name", i.getNickname());
     // Add all groups in this item
     for (Item::iterator it = i.begin(); it != i.end(); it++)
	  item->addElement("group", *it);

     // Transmit item
     _owner << iq.toString().c_str();
//	 _owner.Send();

}

// ---------------------------------------------------------
// Control ops
// ---------------------------------------------------------
void JRoster::deleteUser(const string& jid)
{

     // Send a subscription=remove request...
     Element iq("iq");
     iq.putAttrib("type", "set");
     Element* query = iq.addElement("query");
     query->putAttrib("xmlns", "jabber:iq:roster");
     Element* item = query->addElement("item");
     item->putAttrib("jid", jid);
     item->putAttrib("subscription", "remove");

     // Send it
     _owner << iq.toString().c_str() ;//<< Item(jid, JPresence::ptUnsubRequest);

     // If the user is an Agent then send a remove request
     if ((jid.find("@") == string::npos) && (jid.find("/") != string::npos))
	 {
		 _SigdeleteAgent.join(&Callback_deleteAgent);
//        _owner.queryNamespace("jabber:iq:register", slot(*this, &JRoster::deleteAgent), jid);
          _owner.queryNamespace("jabber:iq:register", _SigdeleteAgent , jid);
	 }
	
}

void Callback_deleteAgent(JSig * inst,const Element & iq)
{
	inst->deleteAgent(iq);
}

// deleteAgentFunc() Ǿ 
// slot() ۼ Լ  κ  ٸ  ߻
// ׷ Ʈ Լ ۼ 
void JRoster::deleteAgent(const Element& iq)
{
     const Element* query = iq.findElement("query");

     Element niq("iq");
     niq.putAttrib("type", "set");
     niq.putAttrib("to", iq.getAttrib("from"));
     Element* nquery = niq.addElement("query");
     nquery->putAttrib("xmlns", "jabber:iq:register");
     nquery->addElement("key", query->getChildCData("key"));
     nquery->addElement("remove");

     // send iit
     _owner << niq.toString().c_str();
}

void JRoster::fetch() const
{
     Element iq("iq");
     iq.putAttrib("type", "get");
     Element* query = iq.addElement("query");
     query->putAttrib("xmlns", "jabber:iq:roster");

     _owner << iq.toString().c_str();
}

// ---------------------------------------------------------
// S10N translation
// ---------------------------------------------------------
string JRoster::translateS10N(Subscription stype)
{
     switch (stype)
     {
     case rsNone:   return "none";
     case rsTo:     return "to";
     case rsFrom:   return "from";
     case rsBoth:   return "both";
     case rsRemove: return "remove";
     }
     return "none";
}

JRoster::Subscription JRoster::translateS10N(const string& stype)
{
     if (stype == "to")
	  return rsTo;
     else if (stype == "from")
	  return rsFrom;
     else if (stype == "both")
	  return rsBoth;
     else if (stype == "remove")
	  return rsRemove;
     else
	  return rsNone;
}

// user@host  ..
string JRoster::filterJID(const string& jid)
{
     // If this jid doesn't have a user, then
     // escape the whole jid and return
     if (jid.find("@") == string::npos)
	  return escape(jid);
     // Otherwise, escape and return just user@host
     else
	  return JID::getUserHost(jid);
     
}

void JRoster::removeItemFromGroup(const string& group, const string& jid)
{
     typedef map<string, set<string> >::iterator GIT;
     GIT it = _groups.find(group);
     // Lookup this group..if found..
     if (it != _groups.end())
     {
	  // Erase the JID in the group-set
	  set<string>::iterator member = it->second.find(jid);
	  if (member != it->second.end()) 
	  {
	       it->second.erase(member);
	  } 
	  // Erase the group-set if it's empty n
	  if (it->second.empty())
	       _groups.erase(it);
     }
}

void JRoster::removeItemFromAllGroups(const Item& item)
{
     // Remove this item from all groups
     for (Item::iterator it = item.begin(); it != item.end(); it++)
     {
	  removeItemFromGroup(*it, item.getJID());
     }
}

void JRoster::mergeItemGroups(const string& itemjid, const set<string>& oldgrp, const set<string>& newgrp)
{
     // Walk the group list and update JRoster::_groups
     // accordingly..icky..slow..wish there was a better
     // way
     set<string>::const_iterator new_it = newgrp.begin();
     set<string>::const_iterator old_it = oldgrp.begin();
     while ((new_it != newgrp.end()) || (old_it != oldgrp.end()))
     {
	  if ((old_it == oldgrp.end()) && (new_it != newgrp.end()))
	  {
	       _groups[*new_it].insert(itemjid);
	       ++new_it;
	  }
	  else if ((old_it != oldgrp.end()) && (new_it == newgrp.end()))
	  {
	       removeItemFromGroup(*old_it, itemjid);
	       ++old_it;
	  }
	  else if ((*old_it) == (*new_it))
	  {
	       ++old_it; 
	       ++new_it;
	  }
	  else
	  {
	       removeItemFromGroup(*old_it, itemjid);
	       ++old_it;
	  }
     }

}

// ---------------------------------------------------------
// IMPLEMENTATION
// 
// JRoster::Item
// ---------------------------------------------------------
//////////////////////////////////////////////////////////////////////////
JRoster::Item::Item(const Element& t)
     : _rescnt(0)
{
     update(t);
}

JRoster::Item::Item(JRoster& r, const Element& t)
     : _rescnt(0)
{
     update(r, t);
}

JRoster::Item::Item(const string& jid, const string& nickname)
     : _jid(jid), _nickname(nickname)
{}

JRoster::Item::~Item()
{}

void JRoster::Item::addToGroup(const string& group)
{
     _groups.insert(group);
}

void JRoster::Item::delFromGroup(const string& group)
{
     _groups.erase(group);
}

void JRoster::Item::clearGroups()
{
     _groups.clear();
}

bool JRoster::Item::update(const Element& t)
{
     _jid = t.getAttrib("jid");

     // If no nickname is available, use standard user@host
     _nickname = t.getAttrib("name");
     if (_nickname == "")
	  _nickname = _jid;
	  
     // Get subscription
     _type = JRoster::translateS10N(t.getAttrib("subscription"));    
     
     // Determine if subscription is pending
     _pending = (t.getAttrib("ask") == "subscribe");

     _groups.clear();
     
     // Parse group set from subtags
     Element::const_iterator it = t.begin();
     for (; it != t.end(); ++it)
     {
	  if ((*it)->getType() != Node::ntElement)
	       continue;
	  string grp_name = static_cast<Element*>(*it)->getCDATA();
	  if (!grp_name.empty())
	       _groups.insert(grp_name);
     }

     // If the subscription is pending, also display them in Pending virtual group
     if (_pending)
     {
	  _groups.insert("Pending");
     }
     // If they're not in a group, display them in Unfiled virtual group
     else if (_groups.empty())
     {
	  // If this jid has no user, but *does* have a resource,
	  // it must be an agent/transport registration
	  if ((_jid.find("@") == string::npos) && (_jid.find("/") != string::npos))
	       _groups.insert("Agents");
	  // Otherwise, it should be displayed in Unfiled
	  else
	       _groups.insert("Unfiled");
     }

     return true;
}

bool JRoster::Item::update(JRoster& r, const Element& t)
{
     // Save old group set
	// ׷ Ѵ.
     set<string> oldGroups = _groups;

	 //Ʈ Ѵ.
     update(t);

     // Have the owner merge it's representation of item groups
     // appropriately
	 // ׷ Ѵ.
     r.mergeItemGroups(_jid, oldGroups, _groups);

     return true;
}


//  ʴ   Ķͷ ѱ?
//   .
void JRoster::Item::update(JRoster& r, const string& jid, const JPresence& p, JPresence::Type prev_type)
{
     bool available = r._owner.getPresenceDB().available(jid);
     
     if ((available == true) && (_rescnt == 0))
     {
	  ++_rescnt;
     }
     else if ((available == false) && (_rescnt == 1))
     {
	  --_rescnt;
     }
	 // khos_debug
	 cout<<"roster evtPresence ȣ..."<<endl;
     //r.evtPresence(jid, (_rescnt != 0), prev_type);
}

bool JRoster::Item::isAvailable() const
{
     return (_rescnt > 0);
}

string JRoster::Item::getNickname() const
{
     return _nickname;
}

void JRoster::Item::setNickname(const string& nickname)
{
     _nickname = nickname;
}

string JRoster::Item::getJID() const
{
     return _jid;
}

void JRoster::Item::setJID(const string& jid)
{
     _jid = jid;
}

JRoster::Subscription JRoster::Item::getSubsType() const
{
     return _type;
}

bool JRoster::Item::isPending() const
{
     return _pending;
}

}//end of JaguarX