
#pragma warning(disable:4355)
#pragma warning(disable:4786)


//#include <IOSTREAM>
//#include <CSTRING>
//#include <STRING>

#include <STDIO.H>

#include "Session.h"

namespace JaguarX
{

void SigFuncElement::join(void(*f)(JSig * inst,const Element &t))
{
	func=f;
}

void SigFuncElement::exec(JSig * inst,const Element& t)
{
	func(inst,t);
}


// ---------------------------------------------------------
// Initializers
//  
// ---------------------------------------------------------
JSession::JSession()
     : ElementStream(this),
       _ID(0),
       _ConnState(csNotConnected),
       _Roster(*this),
       _PDB(*this),
       _StreamStart(false)
{}

//Ҹ : Ǿ  
JSession::~JSession()
{
     // If connected, transmit closing sequence of XML stream...
     if (_ConnState != csNotConnected)
	  disconnect();
}

// ---------------------------------------------------------
// Connection setup/teardown ops (inc. authentication)
// ---------------------------------------------------------
//   Ʈ  .
//  ::connect()Լ ȣ ķ  Լ ȣѴ.
//  evtTransmitXML ̺Ʈ ʱȭ Ǿ ־ Ѵ.

void JSession::connect(const string& server,AuthType atype,
					   const string& username, const string& resource,
					   const string& password, bool newuser)
/*
void JSession::connect(const string& server, AuthType atype, 
		      const string& username, const string& resource, const string& password,
		      bool newuser)
*/
{
     // If already connected, return
     if (_ConnState == csConnected)
	  return;

     // Store properties for future use
     _AuthType = atype;
     _ServerID = server;
     _Username = username;
     _Resource = resource;
     _Password = password;

      // If we haven't connected at all, send the stream header
	 // ȵ..
     if (_ConnState == csNotConnected)
     {
	  this->reset(); // Reset ElementStream for new connection
	  // Transmit opening sequence to establish the XML stream..    
	  *this << "<stream:stream to='" << server.c_str()
		<< "' xmlns='jabber:client' xmlns:stream='http://etherx.jabber.org/streams'>";  
	  // Set state properly..
	  if (!newuser)
	       _ConnState = csAuthReq;
	  else
	       _ConnState = csCreateUser;
     }
     // Otherwise, attempt to authenicate again     
     else
     {
	  if (newuser)
	       _ConnState = csCreateUser;
	  authenticate();
     }
}

//Ʈ   
bool JSession::disconnect()
{
     bool success = false;

     // only disconnect if we have received the starting stream tag to prevent the tagstream from throwing
     // an exception
     if ((_ConnState != csNotConnected) && _StreamStart)
     {
       *this << "</stream:stream>";
       success = true;
     }
     _ConnState = csNotConnected;
     _StreamStart = false;

     return success;
}

// ---------------------------------------------------------
// Accessors
// ---------------------------------------------------------
// Roster ּҸ ´.
const JRoster& JSession::getRosterConst() const
{
     return _Roster;
}

JRoster& JSession::getRoster()
{
     return _Roster;
}

// presenceDB ּҸ ´.
const JPresenceDB& JSession::getPresenceDBConst() const
{
     return _PDB;
}

JPresenceDB&  JSession::getPresenceDB()
{
     return _PDB;
}

JSession::AuthType JSession::getAuthType() const
{
     return _AuthType;
}

const string& JSession::getUserName() const
{
	return _Username;
}

// ---------------------------------------------------------
// Id/auth ops
// ---------------------------------------------------------
// Ʈ ũ ̵ Ѵ.
string JSession::getNextID()
{
     char buf[8];
     _snprintf(buf, 8, "j%u", _ID++);
     return string(buf);
}

// Ʈ  ´.
//  ʿ
string JSession::getDigest()
{
     string basic = _SessionID + _Password;
     return shahash(basic.c_str()); 
}

// ---------------------------------------------------------
// Misc ops
// ---------------------------------------------------------
void JSession::push(const char* data, int datasz)
{
     evtRecvXML(data);
     try {
	  ElementStream::push(data, datasz);
     } catch (const ElementStream::exception::ParserError& error) {
	  // We had a parser error, so nothing's going to be happy
	  evtXMLParserError(error.getCode(), error.getMessage());

	  // Prevent loops :)
	  _ConnState = csNotConnected;
	  _StreamStart = false;

	  disconnect();
     }
}

// khos_remake
//void JSession::registerIQ(const string& id, ElementCallbackFunc)
void JSession::registerIQ(const string& id,SigFuncElement f)
{
	// khos_debug
 	cout<<"##### debug ##### registerIQ "<<id<<endl;
     _Callbacks.insert(make_pair(id, f));
}


// khos_remake done     ۵Ѵ.
// ū Ѵ.
//   result   ޼ ó ڵ鷯
// Լ   ݹʿ  Ǿ Ѵ.
// ׷ ݹʿ Լ Ͱ   ʴ´. (vc++ 6.0 )
// vc++6.0  ϱ ؼ ݹ ڵ鷯  ؾ Ѵ.
//  Ҵ  ʰ ϴ...
//void JSession::queryNamespace(const string& nspace, void(*func)(const Element& e), const string& to)
void JSession::queryNamespace(const string& nspace, SigFuncElement f, const string& to)
{
	// khos_debug
	cout<<"##### debug ##### queryNamespace "<<"[namespace]"<<nspace<<endl;
	
     // Get a unique ID
	//  ޼ ũ ̵ ´.
     string id = getNextID();

	 // <iq type='get' id='some' to='somebody'>
	 //		<query xmlns="some name space">
	 // </iq>

     // Construct a query for this namespace
     Element iq("iq");
     iq.putAttrib("type", "get");
     iq.putAttrib("id", id);
     if (!to.empty())
	  iq.putAttrib("to", to);
     iq.addElement("query")->putAttrib("xmlns", nspace);

     // Register a callback for this IQ
     _Callbacks.insert(make_pair(id, f));

     // Transmit the IQ
	 // IQ޼  Ѵ.
     *this << iq.toString().c_str();
}


// ---------------------------------------------------------
// INTERNAL
//
// Authentication
// ---------------------------------------------------------
void JSession::authenticate()
{
     // Request auth types allowed
     string id = getNextID();
     Element iq("iq");
     iq.putAttrib("type", "get");
     iq.putAttrib("id", id);
     Element* query = iq.addElement("query");
     query->putAttrib("xmlns", "jabber:iq:auth");
     query->addElement("username", _Username, false);
     *this << iq.toString().c_str();

     // If they explicitly set auth, that's the type we use
     // otherwise detect the auth types allowed
     if (_AuthType != JSession::atAutoAuth)
	  sendLogin(_AuthType, NULL);
     else
	 {
		 
		 _SigOnAuthTypeReceived.join(&Callback_OnAuthTypeReceived);
		//registerIQ(id, slot(*this, &JSession::OnAuthTypeReceived));
		registerIQ(id,_SigOnAuthTypeReceived);
	 }
}

void Callback_OnAuthTypeReceived(JSig * inst, const Element& t)
{
	inst->OnAuthTypeReceived(t);
}

void JSession::OnAuthTypeReceived(const Element& t)
{
     // Grab the supported auth types and login using appropriate one
     JSession::AuthType atype = JSession::atPlaintextAuth;
     const Element* query = NULL;
     if (!t.empty())
     {
	  query = t.findElement("query");
	  if (query != NULL)
	  {
	       // Plaintext auth
	       const Element* password = query->findElement("password");
	       if (password != NULL)
		    atype = JSession::atPlaintextAuth;
	       // Digest auth
	       const Element* digest = query->findElement("digest");
	       if (digest != NULL)
		    atype = JSession::atDigestAuth;
	       // Zero-Knowledge
	       const Element* token = query->findElement("token");
	       const Element* sequence = query->findElement("sequence");
	       if (token != NULL && sequence != NULL)
		    atype = JSession::at0kAuth;  // Add 0k support
	  }
     }
     sendLogin(atype, query);
}

void JSession::sendLogin(JSession::AuthType atype, const Element* squery)
{
     // Construct the login
     string id = getNextID();

     // Create the IQ
     Element iq("iq");
     iq.putAttrib("type", "set");
     iq.putAttrib("id", id);

     // Setup the query
     Element* query = iq.addElement("query");

     // Add basic tags
     query->addElement("username", _Username);
     query->addElement("resource", _Resource);
     
     // Handle user creation
     if (_ConnState == csCreateUser)
     {
	  query->putAttrib("xmlns", "jabber:iq:register");
	  query->addElement("password", _Password);

	  // khos_remake done
	  // ݹ Լ ϱ ؼ 
	  // 1) ݹ Լ  Ŭ   
	  // 2)  Լ ȣϴ  Լ 
	  // 3) 1) Ŭ joinԼ  2)Լ 
	  // 4) resisterIQ Ŭ 

	  // Register the create user callback
 	  //registerIQ(id, slot(*this, &JSession::IQHandler_CreateUser)); 
	  _SigIQHandler_CreateUser.join(&Callback_IQHandler_CreateUser);
	  registerIQ(id,_SigIQHandler_CreateUser);

     }
     else if (_ConnState == csAuthReq)
     {
	  query->putAttrib("xmlns", "jabber:iq:auth");
	  // Include necessary passphrase/digest
	  switch (atype)
	  {
	  case atDigestAuth: 
	       query->addElement("digest", getDigest());
	       break;
	  case atPlaintextAuth:
	       query->addElement("password", _Password);
	       break;
	  case at0kAuth:
	       string hashA = shahash(_Password.c_str());
	       string token = squery->getChildCData("token");
	       int seq = atoi(squery->getChildCData("sequence").c_str());
	       string hash = shahash(string(hashA + token).c_str());
	       for (int i = 0; i < seq; i++)
		    hash = shahash(hash.c_str());
	       query->addElement("hash", hash);
	       break;
	  }
	  // khos_remake done
	  // Register the auth callback
	  //registerIQ(id, slot(*this, &JSession::IQHandler_Auth));
	  _SigIQHandler_Auth.join(&Callback_IQHandler_Auth);
	  registerIQ(id,_SigIQHandler_Auth);
     }

     // Transmit the buffer
     *this << iq.toString().c_str();

     // Adjust the connection state
     _ConnState = csAwaitingAuth;
}

// ---------------------------------------------------------
// INTERNAL
//
// ElementStreamEventListener handlers
// ---------------------------------------------------------
void JSession::onDocumentStart(Element* t)
{
     // Retrieve the SID from the stream header
     _SessionID = t->getAttrib("id");
     // Save stream header
     _StreamElement = t;
     _StreamStart = true;
     // Authenticate
     authenticate();
}

void JSession::onElement(Element* t) 
{
     Element& tref = *t;
     // Determine what kind of JPacket we recv'd and call the 
     // appropriate handler
     if (tref.getName() == "message")
	  handleMessage(tref);
     else if (tref.getName() == "presence")
	  handlePresence(tref);
     else if (tref.getName() == "iq")
	  handleIQ(tref);
     else
	  evtUnknownPacket(tref);
     delete t;
}

void JSession::onCDATA(CDATA* c)
{
     // If we ever want to deal with CDATA we receive
     // possibly message sizes and things like that
     // then we do it here.
     delete c;
}

void JSession::onDocumentEnd() 
{
     // Reset roster
     _Roster.reset();
     // Reset the presenceDB
     _PDB.clear();

     // Clear connection state
     _ConnState = csNotConnected;
     _StreamStart = false;

      // Transmit a closing stream tag...
     *this << "</stream:stream>";

     // Fire JSession Disconnect handler
     evtDisconnected();
}

// ---------------------------------------------------------
// INTERNAL
//
// Routing handlers (see also: IQ handlers)
// ---------------------------------------------------------
void JSession::handleMessage(Element& t)
{
     // Call the signal handler
     evtMessage(JMessage(t));
}

void JSession::handlePresence(Element& t)
{
     JPresence p(t);

     // If no sender, it's about my presence
     if (p.getFrom() == "")
     {
	  evtMyPresence(p);
     }

     // If it's a subscription request, fire proper event
     else if ((p.getType() == JPresence::ptSubRequest) ||
	 (p.getType() == JPresence::ptUnsubRequest))
	  evtPresenceRequest(p);

     // Otherwise, examine presence more closely
     else
     {
	  // Determine the previous status for this jid
	  JPresence::Type prev_type;
	  try {
 	       prev_type = _PDB.find(p.getFrom())->getType();
	  } catch (JPresenceDB::XCP_InvalidJID) {
	       prev_type = JPresence::ptUnavailable;
	  }

	  // Insert the packet into the JPresence db
	  _PDB.insert(p);

	  // Check for roster update
	  if (_Roster.containsJID(p.getFrom()))
	       _Roster.update(p, prev_type);	       
	  // pass handling to standard event
	  evtPresence(p, prev_type);
     }
}

void JSession::handleIQ(Element& t)
{
	// khos_remake done
    // Check for callback w/ ID
    typedef multimap<string, SigFuncElement>::iterator CIT;
    pair<CIT, CIT> cb = _Callbacks.equal_range(t.getAttrib("id"));
    if (cb.first != cb.second)
    {
	  // Iterate across the range and fire callbacks
	  for (CIT it = cb.first; it != cb.second; )
	  {
               // Adding a callback with an ID one greater than the ID of this tag
               // screws up the iterator so we need to make sure the id's are actually
               // equal.  Is there a way to prevent the iterator from being broken?
               if (it->first == t.getAttrib("id")) {
	            // Fire the requested function
	            SigFuncElement& f = it->second;
	            f.exec(this,t);
		    // erasing it then incrementing it doesn't work right so increment first
		    // then delete
                CIT nit = it++;
	            _Callbacks.erase(nit);
			   } else
                    it++;
	  }
     }
     // Proceed with xmlns examination
     else
     {
	  Element* q = t.findElement("query");

	  // Catch the odd case of an IQ not having a <query> tag..
	  if (q == NULL) return;

	  // jabber:iq:roster 
	  if (q->cmpAttrib("xmlns", "jabber:iq:roster"))
	  {
	       evtOnRoster();
	       _Roster.update(*q);
	  }

	  // jabber:iq:version
	  if (t.cmpAttrib("type", "get") && q->cmpAttrib("xmlns", "jabber:iq:version"))
	  {
	       string name, ver, os;
	       evtOnVersion(name, ver, os);
	       ver += " (powered by jabberoo 1.1.2)";
	       JPacket iq("iq");
	       iq.getBaseElement().putAttrib("type", "result");
	       iq.setTo(t.getAttrib("from"));
	       iq.setID(t.getAttrib("id"));
	       Element* query = iq.getBaseElement().addElement("query");
	       query->putAttrib("xmlns", "jabber:iq:version");
	       query->addElement("name", name);
	       query->addElement("version", ver);
	       query->addElement("os", os);
	       *this << iq;
	  }
	  // jabber:iq:last
	  else if (t.cmpAttrib("type", "get") && q->cmpAttrib("xmlns", "jabber:iq:last"))
	  {
	       string seconds;
	       evtOnLast(seconds);
	       JPacket iq("iq");
	       iq.getBaseElement().putAttrib("type", "result");
	       iq.setTo(t.getAttrib("from"));
	       iq.setID(t.getAttrib("id"));
	       Element* query = iq.getBaseElement().addElement("query");
	       query->putAttrib("xmlns", "jabber:iq:last");
	       query->putAttrib("seconds", seconds);
	       *this << iq;
	  }
	  // jabber:iq:time
	  else if (t.cmpAttrib("type", "get") && q->cmpAttrib("xmlns", "jabber:iq:time"))
	  {
#ifndef WIN32
	       JPacket iq("iq");
	       iq.getBaseElement().putAttrib("type", "result");
	       iq.setTo(t.getAttrib("from"));
	       iq.setID(t.getAttrib("id"));
	       Element* query = iq.getBaseElement().addElement("query");
	       query->putAttrib("xmlns", "jabber:iq:time");
	       query->addElement("utc", jutil::getTimeStamp());

	       struct tm *loctime;
               time_t curtime;
	       char timestr[1024];

	       curtime = time(0);
	       loctime = localtime(&curtime);

	       // locale-dependent
	       //strftime(timestr, 1024, "%d %b %Y %H:%M:%S", loctime);
	       strftime(timestr, 1024, "%c", loctime);
	       string local= string(timestr); // Local time string
	       strftime(timestr, 1024, "%Z", loctime);
	       string tz = string(timestr); // Time zone
               if (local.find(tz)!=string::npos) // Don't duplicate timezone
                       local.erase(local.find(tz));
	       evtOnTime(local, tz);

	       query->addElement("display", local);
	       query->addElement("tz", tz);
	       *this << iq;
#endif
	  }
	  // Otherwise pass handling to standard event
	  else
	       evtIQ(t);
     }
}



void Callback_IQHandler_Auth(JSig * inst, const Element& t)
{
	inst->IQHandler_Auth(t);
}
// ---------------------------------------------------------
// INTERNAL
//
// Internal IQ handlers
// ---------------------------------------------------------
void JSession::IQHandler_Auth(const Element& t)
{
     // If successful, update connection state
     // and call _Events.OnConnected
     if (t.cmpAttrib("type", "result"))
     {
	  _ConnState = JSession::csConnected;	       // Update connection state
	  evtConnected(*_StreamElement);	       // Notify libuser that connection is available
	  _Roster.fetch();	                       // Request roster
	  delete _StreamElement;		       // Release stream header tag
     }
     else
     {
	  // Handle errors
	  const Element* error = t.findElement("error");
	  if (error != NULL)
	  {
	       _ConnState = JSession::csAuthReq;
	       evtAuthError(atoi(error->getAttrib("code").c_str()), error->getCDATA().c_str());
	  }
	  else
	       evtAuthError(-1, t.toString().c_str());
     }
}

void Callback_IQHandler_CreateUser(JSig * inst, const Element& t)
{
	inst->IQHandler_CreateUser(t);
}

void JSession::IQHandler_CreateUser(const Element& t)
{
     // If successful, update connection state and
     // attempt to authenticate
     _ConnState = JSession::csAuthReq;
     if (t.cmpAttrib("type", "result"))
	  authenticate();
     else
     {
	  const Element* error = t.findElement("error");
	  if (error != NULL)
	  {
	       evtAuthError(atoi(error->getAttrib("code").c_str()), error->getCDATA().c_str());
	  }
     }
}

}//end of JaguarX

