// BaseBar.h : header file
//
/////////////////////////////////////////////////////////////////////////////
//
//  PROJECT: Outlook Express Style
//	MODULE: Base Bar
//	VERSION: 0.1
//
//		OPERATOR: Jeong Sung-won
//		CONTACT: stupi@neoidea.com
//
//		LAST UPDATE: 2002-05-21
//
//
//	Copylefts (c) 2002 Jeong Sung-won
//	All rights NOT reserved.
//

#if !defined(AFX_BASEBAR_H__6EB5FA61_FFAD_11D1_98D4_444553540000__INCLUDED_)
#define AFX_BASEBAR_H__6EB5FA61_FFAD_11D1_98D4_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "BasePane.h"



#define AFX_IDW_BASEBAR		(AFX_IDW_DIALOGBAR + 1)

/////////////////////////////////////////////////////////////////////////////
// CBaseBar window

class CBaseBar : public CControlBar
{
public:
	CBaseBar();


// Attributes
protected:
	CBasePane	m_Pane1;
	CBasePane	m_Pane2;

	int			m_nSize;
	int			m_nSplit;
	int			m_nMinSize;

	CRect       m_rcBorder;
	CRect		m_rcSplit;


// Operations
public:
	void SetPane(BOOL bAlt, LPCTSTR lpszCaption, CWnd* pPaneWnd, BOOL bShow = TRUE);
	void ShowPane(BOOL bAlt, BOOL bShow);
	BOOL PaneIsShow(BOOL bAlt);

protected:
	void TrackSize(CPoint point);
	void TrackSplit(CPoint point);


// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBaseBar)
	public:
	virtual BOOL Create(CWnd* pParentWnd, int nSize, int nSplit, int nMinSize = 100, LPCTSTR lpszCaption = NULL, DWORD dwStyle = WS_CHILD | WS_VISIBLE | CBRS_ALIGN_LEFT | CBRS_SIZE_DYNAMIC, UINT nID = AFX_IDW_BASEBAR);
	virtual CSize CalcFixedLayout( BOOL bStretch, BOOL bHorz );
	virtual CSize CalcDynamicLayout( int nLength, DWORD dwMode );
	virtual void OnUpdateCmdUI(CFrameWnd* pTarget, BOOL bDisableIfNoHndler);
	//}}AFX_VIRTUAL


// Implementation
public:
	virtual ~CBaseBar();


// Generated message map functions
protected:
	//{{AFX_MSG(CBaseBar)
	afx_msg void OnWindowPosChanged(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnNcPaint();
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS FAR* lpncsp);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg UINT OnNcHitTest(CPoint point);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnPaint();
	afx_msg LRESULT OnPaneClose(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};



/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASEBAR_H__6EB5FA61_FFAD_11D1_98D4_444553540000__INCLUDED_)
