// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Aditdera.h"

#include "MainFrm.h"
#include "LeftView.h"
#include "AditderaDoc.h"
#include "AditderaView.h"
#include "ResultView.h"
#include "Searchview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_SEARCH_VIEW, OnSearchView)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_VIEW, OnUpdateSearchView)
	ON_COMMAND(ID_CDLIST_VIEW, OnCdlistView)
	ON_UPDATE_COMMAND_UI(ID_CDLIST_VIEW, OnUpdateCdlistView)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI_RANGE(AFX_ID_VIEW_MINIMUM, AFX_ID_VIEW_MAXIMUM, OnUpdateViewStyles)
	ON_COMMAND_RANGE(AFX_ID_VIEW_MINIMUM, AFX_ID_VIEW_MAXIMUM, OnViewStyle)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	//
	// Create Base Bar & Child Controls
	//

	if(!m_wndBaseBar.Create(this, 200, 250, 100, NULL, WS_CHILD | WS_VISIBLE | CBRS_LEFT | CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create basebar\n");
		return -1;
	}

	if (!m_wndSearchDlgBar.Create(this, IDD_VIEWSELECT,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_VIEWSELECT))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}


	if(!m_wndTreeCtrl.Create(NULL, CRect(0, 0, 0, 0), this, NULL))
	{
		TRACE0("Failed to create tree control\n");
		return -1;
	}

	m_wndBaseBar.SetPane(FALSE,"˻ϱ",&m_wndSearchDlgBar);
	m_wndBaseBar.SetPane(TRUE, "CD List", &m_wndTreeCtrl);

	m_wndBaseBar.SetBarStyle(m_wndBaseBar.GetBarStyle() | CBRS_BORDER_ANY | CBRS_TOOLTIPS | CBRS_FLYBY);



	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	CRect rect;
	GetClientRect(rect);

	// create splitter window
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	int lID = m_wndSplitter.IdFromRowCol(0,0);
	int rID = m_wndSplitter.IdFromRowCol(0,1);

//	m_wndLSplitter.Create(&m_wndSplitter,2,1,CSize(100,100),pContext,WS_CHILD|WS_VISIBLE,lID);
//	m_wndRSplitter.Create(&m_wndSplitter,2,1,CSize(100,100),pContext,WS_CHILD|WS_VISIBLE,rID);
	
	m_wndLSplitter.CreateStatic(&m_wndSplitter,2,1,WS_CHILD|WS_VISIBLE,lID);
	m_wndRSplitter.CreateStatic(&m_wndSplitter,2,1,WS_CHILD|WS_VISIBLE,rID);

	m_wndLSplitter.CreateView(0,0,RUNTIME_CLASS(CSearchview),
		CSize(0,0),pContext);

	m_wndLSplitter.CreateView(1,0,RUNTIME_CLASS(CLeftView),
		CSize(0,0),pContext);


	m_wndRSplitter.CreateView(0,0,RUNTIME_CLASS(CResultView),
		CSize(0,0),pContext);

	m_wndRSplitter.CreateView(1,0,RUNTIME_CLASS(CAditderaView),
		CSize(0,0),pContext);

//	m_wndLSplitter.s
	m_wndLSplitter.SetRowInfo(0,rect.Height()/4,0);
	m_wndRSplitter.SetRowInfo(0,rect.Height()/4,0);
	m_wndSplitter.SetColumnInfo(0,rect.Width()/4,0);
	

	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

CAditderaView* CMainFrame::GetRightPane()
{
	CWnd* pWnd = m_wndSplitter.GetPane(0, 1);
	CAditderaView* pView = DYNAMIC_DOWNCAST(CAditderaView, pWnd);
	return pView;
}

void CMainFrame::OnUpdateViewStyles(CCmdUI* pCmdUI)
{
	// TODO: customize or extend this code to handle choices on the
	// View menu.

	CAditderaView* pView = GetRightPane(); 

	// if the right-hand pane hasn't been created or isn't a view,
	// disable commands in our range

	if (pView == NULL)
		pCmdUI->Enable(FALSE);
	else
	{
		DWORD dwStyle = pView->GetStyle() & LVS_TYPEMASK;

		// if the command is ID_VIEW_LINEUP, only enable command
		// when we're in LVS_ICON or LVS_SMALLICON mode

		if (pCmdUI->m_nID == ID_VIEW_LINEUP)
		{
			if (dwStyle == LVS_ICON || dwStyle == LVS_SMALLICON)
				pCmdUI->Enable();
			else
				pCmdUI->Enable(FALSE);
		}
		else
		{
			// otherwise, use dots to reflect the style of the view
			pCmdUI->Enable();
			BOOL bChecked = FALSE;

			switch (pCmdUI->m_nID)
			{
			case ID_VIEW_DETAILS:
				bChecked = (dwStyle == LVS_REPORT);
				break;

			case ID_VIEW_SMALLICON:
				bChecked = (dwStyle == LVS_SMALLICON);
				break;

			case ID_VIEW_LARGEICON:
				bChecked = (dwStyle == LVS_ICON);
				break;

			case ID_VIEW_LIST:
				bChecked = (dwStyle == LVS_LIST);
				break;

			default:
				bChecked = FALSE;
				break;
			}

			pCmdUI->SetRadio(bChecked ? 1 : 0);
		}
	}
}


void CMainFrame::OnViewStyle(UINT nCommandID)
{
	// TODO: customize or extend this code to handle choices on the
	// View menu.
	CAditderaView* pView = GetRightPane();

	// if the right-hand pane has been created and is a CAditderaView,
	// process the menu commands...
	if (pView != NULL)
	{
		DWORD dwStyle = -1;

		switch (nCommandID)
		{
		case ID_VIEW_LINEUP:
			{
				// ask the list control to snap to grid
				CListCtrl& refListCtrl = pView->GetListCtrl();
				refListCtrl.Arrange(LVA_SNAPTOGRID);
			}
			break;

		// other commands change the style on the list control
		case ID_VIEW_DETAILS:
			dwStyle = LVS_REPORT;
			break;

		case ID_VIEW_SMALLICON:
			dwStyle = LVS_SMALLICON;
			break;

		case ID_VIEW_LARGEICON:
			dwStyle = LVS_ICON;
			break;

		case ID_VIEW_LIST:
			dwStyle = LVS_LIST;
			break;
		}

		// change the style; window will repaint automatically
		if (dwStyle != -1)
			pView->ModifyStyle(LVS_TYPEMASK, dwStyle);
	}
}

void CMainFrame::OnSearchView() 
{
	// TODO: Add your command handler code here
	m_wndBaseBar.ShowPane(FALSE, TRUE);	
}

void CMainFrame::OnUpdateSearchView(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_wndBaseBar.PaneIsShow(FALSE));	
}

void CMainFrame::OnCdlistView() 
{
	// TODO: Add your command handler code here
	m_wndBaseBar.ShowPane(TRUE, TRUE);	
}

void CMainFrame::OnUpdateCdlistView(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!m_wndBaseBar.PaneIsShow(TRUE));	
}
