
//KHOS
//

import java.net.*;
import java.io.*;
import java.util.*;
import java.util.Vector;
import java.awt.*;
import java.util.StringTokenizer;
import java.sql.*;

import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.SQLException; 

import javax.net.ssl.*; //for ssl


class Ping extends Thread
{
	private chatServer xServer;

	public Ping(chatServer server)
	{
		xServer = server;
	}

	public void run()
	{
		while(true)
		{
			try{
				xServer.ping_broadcast();

				sleep(2000);
			}catch(IOException e) {}
			catch(InterruptedException r){}
		}//end while
	}

};


class ChatThread extends Thread
{
	private chatServer xServer;
	private Socket xSocket;

	PrintWriter streamOut;
	BufferedReader streamIn;

	String room_name = "";
	String category = "";
	String password = "";
	String room_no = "";
	String id = "";
	String name = "";
	String maxmember = "";
	String master = "N";
	String sex = "";

	public ChatThread(chatServer server,Socket socket)
	{
		super("Echo service Thread");

		xServer = server;
		xSocket = socket;
		streamOut = null;
		streamIn = null;
	}
	public void sendMessage(String msg)throws IOException
	{
		streamOut.println(msg);
		streamOut.flush();
	}
	public void disconnect()
	{
		try{
			this.streamOut.flush();
			xServer.removeClient(this);
			
			xServer.User_list_broadcast(xServer.User_List(this),this);

			xServer.db_user_delete(this);
			this.streamIn.close();
			this.streamOut.close();
			this.xSocket.close();
			this.stop();
			System.gc();
		}catch(IOException e){}
	}
	public void run()
	{
		System.out.println("Client " + xSocket + " + connect.");
		try{
			streamOut = new PrintWriter(new OutputStreamWriter(xSocket.getOutputStream(),"KSC5601"),true);
			streamIn = new BufferedReader(new InputStreamReader(xSocket.getInputStream(),"KSC5601"),1024);

			String inputLine, outputLine;

			while(true)
			{
				inputLine = streamIn.readLine();

				if(!inputLine.equals("")&&!inputLine.equals(null))
					msg_process(inputLine);

			}//end while
		}catch(Exception w){
			System.out.println(id+"  .");
			disconnect();
		}
	}//end run

	public void msg_process(String inputLine)
	{
		try{
			if(inputLine.regionMatches(0,"001",0,3))
			{
				String new_room_info = inputLine.substring(3).trim();
				master = "Y";

				StringTokenizer stm = new StringTokenizer(new_room_info,"|");

				while(stm.hasMoreTokens())
				{ 
					try{
						room_name = stm.nextToken();
						category = stm.nextToken();
						password = stm.nextToken();
						room_no = stm.nextToken();
						room_no = room_no.trim();
						room_no = room_no.toUpperCase();
						id = stm.nextToken();
						name = stm.nextToken();
						maxmember = stm.nextToken();
						sex = stm.nextToken();
					}catch(NoSuchElementException e){}
				}//end of while
				
				System.out.println(room_name + ":" + category + ":" + password + ":" +
					room_no + ":" + id + ":" + name + ":" + maxmember + ":" + sex);

				xServer.log_check(this);
				xServer.New_Room(this);
				xServer.User_list_broadcast(xServer.User_List(this),this);
			}//end of if
			else if(inputLine.regionMatches(0,"777",0,3))
			{
				String master_id = inputLine.substring(3).trim();
				this.master = "N";
				xServer.change_master(master_id,this);
				xServer.User_list_broadcast(xServer.User_List(this),this);
			}//end of 'else if..."
			else if(inputLine.regionMatches(0,"443",0,3))
			{
				String exit_id = inputLine.substring(3).trim();
				xServer.user_exit(exit_id,this);
				xServer.User_list_broadcast(xServer.User_List(this),this);
			}//end of 'else if..."
			else if(inputLine.regionMatches(0,"002",0,3))
			{
				String Room_In = inputLine.substring(3).trim();
				StringTokenizer stm = new StringTokenizer(Room_In,"|");

				while(stm.hasMoreTokens())
				{
					try{
						room_no = stm.nextToken();
						room_no = room_no.trim();
						room_no = room_no.toUpperCase();
						password = stm.nextToken();
						id = stm.nextToken();
						name = stm.nextToken();
						sex = stm.nextToken();
					}catch(NoSuchElementException e){}
				}//end of while
				xServer.broadcast("000 <br><font color=#0000aa style='font-size:12px'>"
				+ this.id+"  ̽ϴ. </font>",this);

				xServer.log_check(this);
				xServer.Room_In(this);
				xServer.User_List(this);

				xServer.User_list_broadcast(xServer.User_List(this),this);
			}//end of 'else if..."
			else if(inputLine.equals("888"))
			{
				xServer.User_list_broadcast(xServer.User_List(this),this);
			}//end of 'else if..."
			else if(inputLine.equals("000"))
			{
				System.out.println(xServer + " ");
				xServer.broadcast("000 <br><font color = #0000aa style = 'font-size:12px'>"+ this.id + "  ̽ϴ.</font>",this);
				xServer.removeClient(this);
				disconnect();
			}//end of 'else if..."
			else 
			{
				String UserOut = inputLine.substring(0).trim();
				System.out.println(UserOut);
				xServer.broadcast("000 "+UserOut,this);
			}//end of else

		}	catch(IOException e) {}
	}//end of msg_process 
};


////////////////////////////////////////////////////////////////////////////////////////////////
public class chatServer
{
	static chatServer server;
	static Connection con = null;
	static Statement stmt = null;
	static ResultSetMetaData rsmd = null;
	static ResultSet Rs = null;
	static Vector clients = new Vector();
	static Hashtable clients_hash = new Hashtable();
	static Hashtable rooms_hash = new Hashtable();
	static Enumeration broad_enu;
	static Enumeration enu;
	static String User_list="";

	public chatServer(){}
	public synchronized void log_check(ChatThread client)throws IOException
	{
		try{
			if(clients_hash.containsKey(client.id))
			{
				ChatThread thd = (ChatThread)clients_hash.get(client.id);
				thd.streamOut.println("666");
				client.streamOut.println("666");
				thd.disconnect();
			}
		}catch(NullPointerException e){
			System.out.println("ũ üũ  ");
		}
	}

	public void db_user_delete(ChatThread thd)
	{
		try{
			String user_id = thd.id;
			String roomNo = thd.room_no;
			String sql = "delete roomuser where roomno = '"+roomNo+"' and id = '"+user_id+"'";

			System.out.println(sql);

			synchronized(stmt){stmt.executeUpdate(sql);}
		}catch(SQLException t){
			System.out.println("ä  db   : " + t);
		}
	}

	public void db_room_delete(ChatThread thd)
	{
		try{
			String roomNo = thd.room_no;
			String sql = "delete roomlist where roomno='"+roomNo+"'";
			System.out.println(sql);

			synchronized(stmt){stmt.executeUpdate(sql);}
		}catch(SQLException t){
			System.out.println("äù DB   : " + t);
		}
	}
	public void room_db_write(ChatThread thd)
	{
		try{
			String roomtype = thd.category;
			String roomname = thd.room_name;
			String roompass = thd.password;
			String roomno = thd.room_no;
			String maxmember = thd.maxmember;
			String sql = "insert into roomlist(roomtype,roomname,roompass,roomno,	maxmember) values ('"+roomtype+"','"+roomname+"','"+roompass+"','"+roomno+"','"+maxmember+"')";

			System.out.println(sql);

			synchronized(stmt) {stmt.executeUpdate(sql);}
		}catch(SQLException t)
		{
			System.out.println("äù DB   : " + t);
		}
	}
	public void room_db_user_write(ChatThread thd)
	{
		try{
			String DB_id = thd.id;
			String DB_name = thd.name;
			String DB_roomno = thd.room_no;
			String DB_master = thd.master;

			String sql = "insert into roomuser(id,name,roomno,master) values ('"+DB_id+"','"+DB_name+"','"+DB_roomno+"','"+DB_master+"')";

			System.out.println(sql);

			synchronized(stmt) {stmt.executeUpdate(sql);}
		}catch(SQLException t)
		{
			System.out.println("äù DB   : " + t);
		}
	}

	public void User_list_broadcast(String msg,ChatThread thd)throws IOException
	{
		synchronized(clients_hash)
		{
			broad_enu = clients_hash.elements();
			while(broad_enu.hasMoreElements())
			{
				ChatThread client = (ChatThread)broad_enu.nextElement();
				if((client.room_no).equals(thd.room_no))
					synchronized(client){ client.sendMessage(msg);}
			}//end of while
		}//end of synchronized
	}

	public void New_Room(ChatThread thd)
	{
		synchronized (clients_hash) { clients_hash.remove(thd.id);}
		synchronized (rooms_hash) { rooms_hash.remove(thd.room_no);}
		synchronized (clients_hash) { clients_hash.put(thd.id,thd);}
		synchronized (rooms_hash) { rooms_hash.put(thd.room_no,thd);}

		String sql = "delete roomuser where id = '" + thd.id + "'";
		System.out.println(thd.id + "  ");

		try{
			synchronized(stmt) {stmt.executeUpdate(sql);}
		}catch(SQLException t) {}

		sql = "delete roomlist where roomno = '" + thd.room_no + "'";
		System.out.println(thd.room_no + "  ");

		try{
			synchronized(stmt) {stmt.executeUpdate(sql);}
		}catch(SQLException t) {}

		room_db_write(thd);
		room_db_user_write(thd);

	}

	public void Room_In(ChatThread thd)throws IOException
	{
		synchronized (clients_hash) { clients_hash.remove(thd.id);}
		if( rooms_hash.containsKey(thd.room_no))
		{
			System.out.println(" ");
			synchronized (clients_hash) { clients_hash.put(thd.id,thd);}
			synchronized (rooms_hash) { rooms_hash.put(thd.room_no,thd);}

			
			String sql = "delete roomuser where id = '" + thd.id + "'";
			System.out.println(thd.id + "  ");

			try{
				synchronized(stmt) {stmt.executeUpdate(sql);}
			}catch(SQLException t) {}

			room_db_user_write(thd);
		}
		else
		{
			System.out.println(" ");
			synchronized(thd)
			{
				thd.streamOut.println("007");
				thd.streamOut.flush();
			}
			thd.disconnect();
		}
	}

	public synchronized String User_List(ChatThread thd)
	{
		User_list = "999";
		broad_enu = clients_hash.elements();
		while(broad_enu.hasMoreElements())
		{
			ChatThread client = (ChatThread)broad_enu.nextElement();

			if((client.room_no).equals(thd.room_no)) 
				User_list = User_list + client.id + " " + client.name + " " + client.master + " " + client.sex;
		}//end of while
		System.out.println(User_list);

		int i;

		i= User_list.length();
		User_list = User_list.substring(0,i-1);
		return User_list;
	}

	public synchronized void change_master(String master_id, ChatThread thd)
	{
		broad_enu = clients_hash.elements();
		while(broad_enu.hasMoreElements())
		{
			ChatThread client = (ChatThread)broad_enu.nextElement();

			if((client.room_no).equals(thd.room_no) &&
				(client.id).equals(master_id))
			{
				synchronized (client) { client.master = "Y";}
				System.out.println(client.id + " Կ  ο߽ϴ.");
			}
		}//end of while
	}

	public synchronized void user_exit(String exit_id, ChatThread thd) throws IOException
	{
		broad_enu = clients_hash.elements();
		while(broad_enu.hasMoreElements())
		{
			ChatThread client = (ChatThread) broad_enu.nextElement();

			if((client.room_no).equals(thd.room_no) &&
				(client.id).equals(exit_id))
			{
				client.sendMessage("444");
				System.out.println(client.id + "  Ͽϴ.");
				client.disconnect();
			}
		}//end of while
	}

	public void broadcast(String msg,ChatThread thd) throws IOException
	{
		synchronized(clients_hash)
		{
			broad_enu = clients_hash.elements();
			while(broad_enu.hasMoreElements())
			{
				ChatThread client = (ChatThread)broad_enu.nextElement();
				if((client.room_no).equals(thd.room_no) &&
					!(client.id).equals(thd.id))
				{
					synchronized(client){ client.sendMessage(msg);}
				}
			}//end of while
		}
	}

	public void removeClient(ChatThread thd)
	{
		synchronized(clients_hash) { clients_hash.remove(thd.id);}
		db_user_delete(thd);
		enu = clients_hash.elements();
		String index = "N";

		while(enu.hasMoreElements())
		{
			ChatThread client = (ChatThread)enu.nextElement();

			if((client.room_no).equals(thd.room_no)) index = "Y";

		}
		if(index.equals("N"))
		{
			synchronized(rooms_hash) { rooms_hash.remove(thd.room_no);}
			db_room_delete(thd);
		}
	}

	public void client_add_Vector(ChatThread thd)
	{
		synchronized(clients) { clients.addElement(thd);}
	}

	public void ping_broadcast() throws IOException
	{
		try{
			Enumeration enu = clients_hash.elements();
			while(enu.hasMoreElements())
			{
				ChatThread thd = (ChatThread)enu.nextElement();
				thd.sendMessage("");
			}//end of while
		}catch(NullPointerException e) {}
	}

	public static void main(String[] args)
	{
		SSLServerSocketFactory ssf = (SSLServerSocketFactory)SSLServerSocketFactory.getDefault();
		ServerSocket serverSocket = null;
		int port =7942;
		try
		{
	
            Class.forName("com.mysql.jdbc.Driver").newInstance(); 

			con = DriverManager.getConnection("jdbc:mysql://localhost/chat_table?user=root&password=apmsetup");
			stmt = con.createStatement();
          
		}catch(java.lang.ClassNotFoundException e)
		{
			System.out.println(e);
		}catch(SQLException r)
		{
            System.out.println("SQLException: " + r.getMessage()); 
            System.out.println("SQLState: " + r.getSQLState()); 
            System.out.println("VendorError: " + r.getErrorCode()); 
        } catch (Exception ex) {  }

		server =new chatServer();

		try{
//			serverSocket = new ServerSocket(port);
			serverSocket = ssf.createServerSocket(port); //for ssl
		}catch(IOException e)
		{
			System.err.println("Ͽ");
			System.exit(-1);
		}

		System.out.println("Starting Server...");

		Ping ping_send;
		ping_send = new Ping(server);
		ping_send.start();

		try{
			while(true)
			{
				ChatThread thread;
				thread = new ChatThread(server,serverSocket.accept());
				thread.start();
				server.client_add_Vector(thread);
				System.gc();
			}
		}catch(IOException e)
		{
			System.out.println("Server Die...");
			e.printStackTrace();
		}
	}
};