////////////////////////////////////// node stucture //////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////// Double_Llist Class /////////////////////////////////////
template <class data_type>
class Double_Llist
{
	struct node
	{
		data_type data;
		node* prev;
		node* next;
	};//end struct node

	node* head;
	node* tail;
	node* current;
	int length;

public:
	Double_Llist();
	~Double_Llist();
//	void Insert_data(node* Temp, data_type value);
//	void Print_all();
//	void Print_one();
	bool Insert(data_type* data);
	bool Delete();
	bool Delete_all();
	bool Modify(data_type* data);
	bool Move2previous();
	bool Move2next();
	bool Move2first();
	bool Move2last();
	int Get_data(data_type* data);
	int Get_length();
};//end class Double_Llist
/////////////////////////////////////////////////////////////////////////////////////////////
template <class data_type>
Double_Llist<data_type>::Double_Llist()
{
	head = new node;
	tail = new node;
	head->prev = head;
	head->next = tail;
	tail->prev = head;
	tail->next = tail;
	current = NULL;
	length = 0;
}
template <class data_type>
Double_Llist<data_type>::~Double_Llist()
{
	Delete_all();
	delete head;
	delete tail;
}
	
template <class data_type>
bool Double_Llist<data_type>::Insert(data_type* value)
{        
	if (current == head || current == tail)
		return 0;

	node *temp = new node;        
	if(!temp)        
		return 0;

	temp->data = *value;

	if(current == NULL)   
	{
		temp->prev = head;
		temp->next = tail;
		tail->prev = temp;
		head->next = temp;
	}
	else {
		temp->prev = current;
		temp->next = current->next;
		current->next->prev = temp;
		current->next = temp;
	}

	current = temp;
	length++;
	return 1;    	
}

/*template <class data_type>
void Double_Llist<data_type>::Insert_data(node* temp, data_type data)
{        
	temp->data = data;
}
*/
template <class data_type>
bool Double_Llist<data_type>::Delete()
{
	bool moreToDelete;

	if (current == NULL || current == head || current == tail)
		return 0;

	if (current->prev == head && current->next == tail)
	{
		delete current;
		current = NULL;
		head->prev = head;
		head->next = tail;
		tail->prev = head;
		tail->next = tail;
		moreToDelete = false;
	}
	else {
		node* temp;
		if (current->prev == head)
			temp = current->next;
		else
			temp = current->prev;
		current->prev->next = current->next;
		current->next->prev = current->prev;
		delete current;
		current = temp;
		moreToDelete = true;
	}

	length--;
	return moreToDelete;
}

template <class data_type>
bool Double_Llist<data_type>::Modify(data_type* data)
{
	if (current == NULL || current == head || current == tail)
		return NULL;
	current->data = *data;
	return 1;
}

template <class data_type>
bool Double_Llist<data_type>::Delete_all()
{
	if(!current)
	{
		return 0;
	}
	current = head->next;
	while(Delete())
		current = current -> next;
		
	return 1;
}

/*
template <class data_type>
void Double_Llist<data_type>::Print_one()
{
	if (current == NULL || current == head || current == tail)
		return;
	cout<<current->data;
}

template <class data_type>
void Double_Llist<data_type>::Print_all()
{
	if (current == NULL || current == head || current == tail)
		return; 

	node *temp;
	temp = current;
	current = head;
	while (current->next != tail)
	{
		current = current->next;
		Print_one();
	}
	current = temp;
}
*/
template <class data_type>
bool Double_Llist<data_type>::Move2previous()
{
	if (current == NULL || current->prev == head)
		return 0;
	current = current -> prev;
	return 1;
}

template <class data_type>
bool Double_Llist<data_type>::Move2next()
{
	if (current == NULL || current->next == tail)
		return 0;
	current = current -> next;
	return 1;
}

template <class data_type>
bool Double_Llist<data_type>::Move2first()
{
	if (current == NULL)
		return 0;
	current = head->next;
	return 1;
}

template <class data_type>
bool Double_Llist<data_type>::Move2last()
{
	if (current == NULL)
		return 0;
	current = tail->prev;
	return 1;
}

template <class data_type>
int Double_Llist<data_type>::Get_data(data_type* data)
{
	if(current)
	{
		*data = current->data;
		return true;
	}
	else
		return false;
}

template <class data_type>
int Double_Llist<data_type>::Get_length()
{
	return length;
}