#include "buffer_module.h"

Session_Buf::Session_Buf()
{
	count = 0;
}

Session_Buf::~Session_Buf()
{
}

int Session_Buf::insertSession(const Session_Record& SR)
{
	if (count >= SESSION_BUFFER_SIZE)
		return BM_RSP_BUFFERFULL;
	Ses_Buf[count] = SR;
	count ++;
	return BM_RSP_INSERTED;
}

int Session_Buf::findSessionIndex(const char* ID)
{
	bool found = false;
	int i = 0;
	int j;
	while(i < count && !found)
	{
		j = 0;
		found = true;
		while(j < ID_SIZE)
		{
			if(Ses_Buf[i].ID[j] != ID[j])
			{
				found = false;
				break;
			}//end if
			j++;
		}// end while j
	
		i++;
	}

	if (found)
		return i-1;
	else
		return BM_RSP_RECORDNOTFOUND;
}
int Session_Buf::findSessionIndex(const SOCKET& c_sok)
{
	bool found = false;
	int i =0;
	while (i<count && !found)
	{
		if(Ses_Buf[i].Client_Socket == c_sok)
		{
			found = true;
			break;
		}
		i++;
	}
	if (found)
		return i;
	else
		return BM_RSP_RECORDNOTFOUND;
}
int Session_Buf::findSession(const char* ID, Session_Record& SR)
{
	int i;
	if ((i = findSessionIndex(ID)) != BM_RSP_RECORDNOTFOUND)
	{
		SR = Ses_Buf[i];
		return BM_RSP_RECORDFOUND;
	}
	else
		return BM_RSP_RECORDNOTFOUND;
}

int Session_Buf::findSession(const SOCKET& c_sok, Session_Record& SR)
{
	int i;
	if ((i = findSessionIndex(c_sok)) != BM_RSP_RECORDNOTFOUND)
	{
		SR = Ses_Buf[i];
		return BM_RSP_RECORDFOUND;
	}
	else
		return BM_RSP_RECORDNOTFOUND;
}

int Session_Buf::deleteSession(const char* ID)
{
	int i;
	if ((i = findSessionIndex(ID)) != BM_RSP_RECORDNOTFOUND)
	{
		for(int j = i; j < count-1; j++)
			Ses_Buf[j] = Ses_Buf[j+1];
		count --;
		return BM_RSP_RECORDFOUND;
	}
	else
		return BM_RSP_RECORDNOTFOUND;
}

int Session_Buf::deleteSession(const SOCKET& c_sok)
{
	int i = findSessionIndex(c_sok);
	if (i != BM_RSP_RECORDNOTFOUND)
	{
		for (int j = i; j < count-1; j++)
			Ses_Buf[j] = Ses_Buf[j+1];
		count--;
		return BM_RSP_RECORDFOUND;
	}
	else
		return BM_RSP_RECORDNOTFOUND;
}

int Session_Buf::modifySession(const SOCKET& c_sok, const Session_Record& SR)
{
	int i = findSessionIndex(c_sok);
	if (i != BM_RSP_RECORDNOTFOUND)
	{
		Ses_Buf[i] = SR;
		return BM_RSP_RECORDFOUND;
	}
	else
		return BM_RSP_RECORDNOTFOUND;
}

