#include"fileIO.h"

fileIO::fileIO()
{
	status = NONE;
}

fileIO::fileIO(string FName)
{
	FileName = FName;
	open(FileName, false);
}

fileIO::fileIO(string FName, bool Makefile)
{
	FileName = FName;
	open(FileName, Makefile);
}

fileIO::~fileIO()
{
	if(file.is_open())
		file.close();
}

void fileIO::open(string FName, bool Makefile)
{
	FileName = FName;
	file.open(FName.c_str(),ios::in|ios::out|ios::binary);
	if(!file) status = OPEN_FAIL;
	else status = READY;
}

void fileIO::close()
{
	file.close();
	status = NONE;
}

void fileIO::read2buffer(char* buffer, int beg_pointer, int size)
{
	file.seekp(beg_pointer, ios::beg);
	file.read(buffer,size);
}

void fileIO::writebuffer(char* buffer, int beg_pointer, int size)
{
	file.seekp(beg_pointer, ios::beg);
	file.write(buffer, size);
}

void fileIO::writeAttheEnd(char* buffer, int size)
{
	file.write(buffer, size);
}

fileIO_StatusType fileIO::getStatus()
{
	return status;
}

string fileIO::getFileName()
{
	return FileName;
}

/*
void main()
{
	fileIO f("test.txt");
	char* buffer = new char[80];

	switch (f.getStatus())
	{
	case READY: cout<<"status = ready"<<endl;
		break;
	case NONE: 	cout<<"status = none"<<endl;
		break;
	case OPEN_FAIL: cout<<"status = open fail"<<endl;
		break;
	}
	cout<<f.getFileName()<<endl;
	f.read2buffer(buffer,0,5);
	strcpy(buffer,"HongYoonKi");
	f.writebuffer(buffer,5,12);
	cout<<buffer<<endl;
}*/