// Signature & Version
#define OSPP_SIG1 3267870911		//Signature 1
#define OSPP_SIG2 3133002428		//Signature 2
#define OSPP_VERS 4172926912

// client query
#define OSPP_AUTH 4123119296		//request authentication
#define OSPP_RFRS 0000000000		//refresh list
#define OSPP_CHTC 3284575427		//chat request (client)
#define OSPP_CCLS 3803307444		//closing connection (client)

// server query
#define OSPP_SDAU 4055554241		//request authentication data

// server response
#define OSPP_APRV 4172331708		//approved
#define OSPP_RJCT 2998448838		//rejected
#define OSPP_FAIL 3502688189
#define OSPP_ERR0 2948047295		//error
#define OSPP_SCLS 3803307444		//closing connection (server)
#define OSPP_FLIF 3098649540		//friend list information(ģ)
#define OSPP_FLRQ 3099239617		//friend list request()
#define OSPP_ECHO 3670319551		//echoed data (chat)
#define OSPP_CHTS 2915625908		//chat data (from friend)


// packet structure information
#define SIGNATURE_SIZE	 8			//size of Signature
#define VERSION_SIZE	 4			//size of Version
#define QR_TYPE_SIZE	 4			//size of QR_Type
#define DLG_ID_SIZE		 1			//size of Dialog ID field
#define NUM_FIELD_SIZE	 1			//size of NF field
#define FIELD_LEN_SIZE	 1			//size of FL field
#define FIELD_LEN_MAX    13 		//max FL field
#define CHECK_SUM_SIZE	 1			//size of CS field
#define MESSAGE_MAX      68			//size of message

// others
#define ID_MAX_LEN		 16
#define PWD_MAX_LEN		 16

class Packet
{
	unsigned int OSP_Sig1, OSP_Sig2;
	unsigned int OSP_Version;
	unsigned int QR_Type;
	char DLG_ID;
	char Num_Field;
	char Field_Len[FIELD_LEN_MAX];
	char Check_Sum;
	char message[MESSAGE_MAX];
public:
	Packet();
	Packet(const Packet& Source);
	~Packet();
	Packet operator = (const Packet& Source);
	
	void InsertSignVer();
	void InsertSignature(char* Signature);
	void InsertSignature(unsigned int Sig1, unsigned int Sig2);
	void InsertVersion(char* Version);
	void InsertVersion(unsigned int Version);
	void InsertQR_Type(int QR);
	void InsertDLG_ID(int DID);
	void InsertCheckSum(int CS);
	void InsertHeader(char* Signature, char* Version, int QR, int DID);
	int AppendField(char* Field);
	int AppendField(char ch);
	int AppendField(int number);
	bool IsHeaderValid();
	char* GetSignature();
	char* GetVersion();
	int GetDLG_ID();
	int GetQR_Type();
	int GetNum_Field();
	int GetField(int index, char* field);
	int GetField_Len(int index);
	char* GetPacketStream();
	int GetPacketSize();
};