#include "osp_protocol.h"
#include<iostream>
using namespace std;
////////////////////////////////Analyzing////////////////////////////////////////

int Analyze(char* buffer, 
			SOCKET c_sok, 
			Packet** Pack,
			Session_Buf* Sess_Buffer)
{	
	int PacketValid = true;

	Session_Record SR;
	
	if(Sess_Buffer->findSession(c_sok, SR) >= 0)
	{
		*Pack = (Packet*) buffer;

		//Validation check
		if(!(*Pack)->IsHeaderValid())			
			PacketValid = false;

		else if ((*Pack)->GetNum_Field()> FIELD_LEN_MAX)
			PacketValid = false;
		
		if (!PacketValid)
		{
			if(SR.Session_Status == SS_STATUS_ILLEGALTRY2)
			{//3rd illegal try, delete session, close socket
				PacketValid = OSPT_CONNECTEION_CLOSE;
			}// end if
			else
			{//update session and send error message
				SR.Session_Status = (abs(SR.Session_Status) + 1) * -1;
				Sess_Buffer->modifySession(c_sok, SR);
				PacketValid = false;
			}// end else
		}//end if
	}
	else
	{
		cout<<"AZ : Session Not Found"<<endl;
		PacketValid = OSPT_CONNECTEION_CLOSE;
	}//end else
		
	return PacketValid;
}//end Analyze()

////////////////////////////////Decoding////////////////////////////////////////
void Decode(Packet& Pack)
{
	return;
}

////////////////////////////////Packet_Processing///////////////////////////////
int Packet_Process(Packet* Pack,
					SOCKET c_sok, 
					Packet& Pack2Send,
					Session_Buf* Sess_Buffer)
{
	//commonly used variables
	Session_Record SR, Friend_SR;
	//CHTC variables
	char* FID;
	char* ID;
	char* PWD;
	char* Message;
	Packet Pack_Temp;
	int AuthenResult;
	int Num_Friend = 0;
	int buf_pointer = 0;
	int i;
	
	if(Sess_Buffer->findSession(c_sok, SR) >= 0)
	{
		switch(Pack->GetQR_Type())
		{
		case OSPP_AUTH :
		   	if(SR.User_Status == SS_STATUS_USERONLINE || 
				Pack->GetNum_Field() != 2 ||
				Pack->GetField_Len(0) > ID_MAX_LEN ||
				Pack->GetField_Len(0) <= 0 ||
				Pack->GetField_Len(1) > PWD_MAX_LEN ||
				Pack->GetField_Len(1) <= 0)
				
			{//Illegal packet	
				if(SR.Session_Status == SS_STATUS_ILLEGALTRY2)
				{//3rd illegal try, delete session, close socket
					//WaitForSingleObject(hSB_Mutex, INFINITE);
					//	Sess_Buffer.deleteSession(c_sok);
					//ReleaseMutex(hSB_Mutex);
					//closesocket(c_sok);
					return OSPT_CONNECTEION_CLOSE;
				}// end if
				else
				{//update session and send error message
					SR.Session_Status = (abs(SR.Session_Status) + 1) * -1;
					Sess_Buffer->modifySession(c_sok, SR);
					Pack2Send.InsertQR_Type(OSPP_ERR0);
					return true;
				}// end else
			}// end if
			ID = new char[Pack->GetField_Len(0)+1];
			PWD = new char[Pack->GetField_Len(1)+1];
			
			Pack->GetField(0, ID);
			Pack->GetField(1, PWD);

			AuthenResult = AuthenCheck(ID, PWD);

			delete ID;
			delete PWD;
			
			switch(AuthenResult)
			{		
			case DB_RSP_WRONGPWD :						
			case DB_RSP_IDNOTFOUND :
				if (SR.Session_Status == SS_STATUS_ILLEGALTRY2)
				{//3rd try, delete session, close socket
					//WaitForSingleObject(hSB_Mutex, INFINITE);
					//	Sess_Buffer.deleteSession(c_sok);
					//ReleaseMutex(hSB_Mutex);
					//closesocket(c_sok);
					return OSPT_CONNECTEION_CLOSE;
				}// end if
				else
				{
					SR.Session_Status = (abs(SR.Session_Status) + 1) * -1;
					Sess_Buffer->modifySession(c_sok, SR);
					Pack2Send.InsertQR_Type(OSPP_RJCT);
					return true;
				}// end else
			case DB_RSP_APPROVED :
				SR.User_Status = SS_STATUS_USERONLINE;

				ID = new char[Pack->GetField_Len(0)+1];
				Pack->GetField(0, ID);

				SR.InsertID(ID);

				delete ID;

				Sess_Buffer->modifySession(c_sok, SR);
				Pack2Send.InsertQR_Type(OSPP_APRV);
				return true;
			default :
				return false;
			}// end switch
	 	   
		case OSPP_RFRS :
		case OSPP_CHTC :
			//Packet Validation Check
			Num_Friend = (Pack->GetNum_Field() - 1)/2;

			if(Pack->GetNum_Field() != ((Num_Friend * 2) + 1))
			{
				if(SR.Session_Status == SS_STATUS_ILLEGALTRY2)
				{//3rd illegal try, delete session, close socket
					//WaitForSingleObject(hSB_Mutex, INFINITE);
					//	Sess_Buffer.deleteSession(c_sok);
					//ReleaseMutex(hSB_Mutex);
					//closesocket(c_sok);
					return OSPT_CONNECTEION_CLOSE;
				}// end if
		
				else
				{//update session and send error message
					SR.Session_Status = (abs(SR.Session_Status) + 1) * -1;;
					Sess_Buffer->modifySession(c_sok, SR);
					Pack2Send.InsertQR_Type(OSPP_ERR0);
					return true;
				}// end else
			}//end if

			//Create ECHO Packet
			Pack2Send.InsertQR_Type(OSPP_ECHO);
			Pack2Send.InsertDLG_ID(Pack->GetDLG_ID());
			Message = new char[Pack->GetField_Len(Pack->GetNum_Field() - 1)+1];
			Pack->GetField(Pack->GetNum_Field() - 1, Message);
			Pack2Send.AppendField(Message);
			delete Message;

			for ( i = 0; i < Num_Friend; i++ )
			{
				FID = new char[Pack->GetField_Len(i * 2) + 1];
				Pack->GetField(i*2,FID);
				if(Sess_Buffer->findSession(FID, Friend_SR) >= 0)
				{
					//fill up buffer
					Pack_Temp.InsertQR_Type(OSPP_CHTS);
					Message = new char[Pack->GetField_Len(i*2+1)+1];
					Pack->GetField(i*2+1, Message);
					Pack_Temp.InsertDLG_ID((int)Message[0]);
					delete Message;
					Pack_Temp.AppendField(SR.ID);
					Pack_Temp.AppendField(Pack->GetDLG_ID());
					Message = new char[Pack->GetField_Len(Pack->GetNum_Field() - 1)+1];
					Pack->GetField(Pack->GetNum_Field() - 1, Message);
					Pack_Temp.AppendField(Message);
					delete Message;
					
					//send packet
					send(Friend_SR.Client_Socket, Pack_Temp.GetPacketStream(), 
						Pack2Send.GetPacketSize(),0);
				}// end if
				else
				{
					//store FID
					Message = new char[Pack->GetField_Len(i*2)+1];
					Pack->GetField(i*2,Message);
					Pack2Send.AppendField(Message);
					delete Message;
					Message = new char[Pack->GetField_Len(i*2+1) + 1];
					Pack->GetField(i*2+1,Message);
					Pack2Send.AppendField(Message[0]);
					delete Message;
				}
				delete FID;
			}// end for

			return true;
/////////////////////// Friend list information request ////////////////////////////////
		case OSPP_FLRQ :
			
			try
			{
				if(SR.User_Status == SS_STATUS_USERONLINE)
				{
					Pack2Send.InsertQR_Type(OSPP_FLIF);
					Pack2Send.InsertDLG_ID(Pack->GetDLG_ID()); //should be 0

					if(FindFriendInfo(SR.ID, &Pack2Send))
						return true;
				}// end if
			}// end try
			catch (BadQuery er)
			{ 	} 
			catch (BadConversion er) 
			{	}
			return false;
		case OSPP_CCLS :
		break;
		}// end switch
	}// end session if
	else
	{
		return false;
	}// end else
	return 0;
}